{===================================================================================================

  Bugs Free QuickReport.

        .

====================================================================================================

  :

  25.10.2001 TSK    .

====================================================================================================
  Copyright 2001-2004 TSK Developer Laboratory, Moscow.               Konstantin Tsvetkov
                                                                        e-mail: tsklab@mail.ru
                                                                        http://tsklab.narod.ru
===================================================================================================}
{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: QuickReport 3.0 for Delphi and C++Builder               ::
  ::                                                         ::
  :: QRPRNTR.PAS - LOW LEVEL PRINT AND PREVIEW CLASSES       ::
  ::                                                         ::
  :: Copyright (c) 1999 QuSoft AS                            ::
  :: All Rights Reserved                                     ::
  ::                                                         ::
  :: web: http://www.qusoft.no                               ::
  ::                                                         ::
  :: Updated by Bugs Free QR Team 2001-02                    ::
  :: http://bfqr.da.ru                                       ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

{$I QRDEFS.INC}

unit QRPrntr;

{$R-}
{$T-}
{$B-}

interface

uses
  Windows, winspool, Sysutils, Messages, Classes, Controls, StdCtrls, ExtCtrls,
  ComCtrls, {Buttons, }Printers, Graphics, Forms, {RAA DB, DBTables, }QR3Const{, Dialogs}
  ,QRPool
  ;
type
  { All the known paper sizes }
  TQRPaperSize = (Default,
                  Letter,
                  LetterSmall,
                  Tabloid,
                  Ledger,
                  Legal,
                  Statement,
                  Executive,
                  A3,
                  A4,
                  A4Small,
                  A5,
                  B4,
                  B5,
                  Folio,
                  Quarto,
                  qr10X14,
                  qr11X17,
                  Note,
                  Env9,
                  Env10,
                  Env11,
                  Env12,
                  Env14,
                  CSheet,
                  DSheet,
                  ESheet,
//>RSV
                  EnvelopeDL,
                  EnvelopeC5,
                  EnvelopeC3,
                  EnvelopeC4,
                  EnvelopeC6,
                  EnvelopeC65,
                  EnvelopeB4,
                  EnvelopeB5,
                  EnvelopeB6,
                  EnvelopeItaly,
                  EnvelopeMonarch,
                  Envelope6x3_4,
                  USStdFanfold,
                  GermanStdFanfold,
                  GermanLegalFanfold,
                  Fanfold,
//<RSV
                  Custom);

  TQRBin = (First,
            Upper,
            Lower,
            Middle,
            Manual,
            Envelope,
            EnvManual,
            Auto,
            Tractor,
            SmallFormat,
            LargeFormat,
            LargeCapacity,
            Cassette,
            Last);

const
   cQRName = 'QuickReport 3.0.8'; { This string should not be resourced }
   cQRVersion = 308;
   cQRPDefaultExt = 'QRP';      { Default extesion for QRP files }
   cQRDefaultExt = 'QR';        { Default extesion for QR files }
   { Actual paper sizes for all the known paper types }
//RSV   cQRPaperSizeMetrics : array[Letter..ESheet, 0..1] of extended =
   cQRPaperSizeMetrics : array[Letter..Fanfold, 0..1] of extended =
      ((215.90,  279.40), { Letter }
       (215.90,  279.40), { Letter small }
       (279.40,  431.80), { Tabloid }
       (431.80,  279.40), { Ledger }
       (215.90,  355.60), { Legal }
       (139.70,  215.90), { Statement }
       (190.50,  254.00), { Executive }
       (297.00,  420.00), { A3 }
       (210.00,  297.00), { A4 }
       (210.00,  297.00), { A4 small }
       (148.00,  210.00), { A5 }
       (250.00,  354.00), { B4 }
       (182.00,  257.00), { B5 }
       (215.90,  330.20), { Folio }
       (215.00,  275.00), { Quarto }
       (254.00,  355.60), { 10X14 }
       (279.40,  431.80), { 11X17 }
       (215.90,  279.00), { Note }
       ( 98.43,  225.40), { Envelope #9 }
       (104.80,  241.30), { Envelope #10 }
       (114.30,  263.50), { Envelope #11 }
       (101.60,  279.40), { Envelope #12 - might be wrong !! }
       (127.00,  292.10), { Envelope #14 }
       (431.80,  558.80), { C size sheet }
       (558.80,  863.60), { D size sheet }
       (863.60, 1117.60), { E size sheet }
//>RSV
       (110.00,  220.00), { Envelope DL }
       (162.00,  229.00), { Envelope C5 }
       (324.00,  458.00), { Envelope C3 }
       (229.00,  324.00), { Envelope C4 }
       (114.00,  162.00), { Envelope C6 }
       (114.00,  229.00), { Envelope C65 }
       (250.00,  353.00), { Envelope B4 }
       (176.00,  250.00), { Envelope B5 }
       (176.00,  125.00), { Envelope B6 }
       (110.00,  230.00), { Envelope }
       ( 98.40,  190.50), { Envelope Monarch }
       ( 92.10,  165.10), { Envelope 6 3/4 }
       (377.80,  279.40), { US Std Fanfold }
       (215.90,  304.80), { German Std Fanfold }
       (215.90,  330.20), { German Legal Fanfold }
       (215.90,  304.80)  { Fanfold 8,5 x 12 }
//       (100.00,  100.00)  { QR Custom }
//<RSV
       );

   { Table for translating TQRPaperSize to values which can be used with the
     printer driver }
//RSV   cQRPaperTranslate : array[Default..Custom] of integer =
   cQRPaperTranslate : array[Default..Custom] of integer =
       (0,
       dmpaper_Letter,
       dmpaper_LetterSmall,
       dmpaper_Tabloid,
       dmpaper_Ledger,
       dmpaper_Legal,
       dmpaper_Statement,
       dmpaper_Executive,
       dmpaper_A3,
       dmpaper_A4,
       dmpaper_A4Small,
       dmpaper_A5,
       dmpaper_B4,
       dmpaper_B5,
       dmpaper_Folio,
       dmpaper_Quarto,
       dmpaper_10X14,
       dmpaper_11X17,
       dmpaper_Note,
       dmpaper_Env_9,
       dmpaper_Env_10,
       dmpaper_Env_11,
       dmpaper_Env_12,
       dmpaper_Env_14,
       dmpaper_CSheet,
       dmpaper_DSheet,
       dmpaper_ESheet,
//>RSV
       DMPAPER_ENV_DL,
       DMPAPER_ENV_C5,
       DMPAPER_ENV_C3,
       DMPAPER_ENV_C4,
       DMPAPER_ENV_C6,
       DMPAPER_ENV_C65,
       DMPAPER_ENV_B4,
       DMPAPER_ENV_B5,
       DMPAPER_ENV_B6,
       DMPAPER_ENV_ITALY,
       DMPAPER_ENV_MONARCH,
       DMPAPER_ENV_PERSONAL,
       DMPAPER_FANFOLD_US,
       DMPAPER_FANFOLD_STD_GERMAN,
       DMPAPER_FANFOLD_LGL_GERMAN,
       DMPAPER_ISO_B4,
//<RSV
       $100);

   cQRBinTranslate : array[First..Last] of integer =
     (1, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 14, 14);

   qrpMINZOOM = 2;
   qrpMAXZOOM = 2000;

type
  TQRBandType = (rbTitle,
                 rbPageHeader,
                 rbDetail,
                 rbPageFooter,
                 rbSummary,
                 rbGroupHeader,
                 rbGroupFooter,
                 rbSubDetail,
                 rbColumnHeader,
                 rbOverlay,
                 rbChild);

const
  { Misc constants }
  cQRPageShadowWidth = 2;
  cQRPageFrameWidth = 1;
  cQRPageShadowColor = clBlack;
  cQRCornerSize = 4;

  { TQRCompress related declarations }

const
  { TQRCompress constants }
  MaxChar = 256;
  EofChar = 256;
  PredMax = 255;
  TwiceMax = 512;
  ROOT = 0;
  BitMask : array[0..7] of Byte = (1, 2, 4, 8, 16, 32, 64, 128);

  CM_QRPROGRESSUPDATE = WM_USER + 0;
  CM_QRPAGEAVAILABLE = WM_USER + 1;
  CM_QRPRINT = WM_USER + 2;
  CM_QRPRINTSETUP = WM_USER + 3;
  CM_QRPREVIEWCLOSE = WM_USER + 4;
  CM_QRPRINTWITHSETUP = WM_USER + 5;
  CM_QRREPREVIEW = WM_USER + 6;
  CM_QRSWAPPRINTER = WM_USER + 7;
  
type
  TQRPrinter = class;

  EQRError = class(Exception);

  CodeType = 0..MaxChar;
  UpIndex = 0..PredMax;
  DownIndex = 0..TwiceMax;
  TreeDownArray = array[UpIndex] of DownIndex;
  TreeUpArray = array[DownIndex] of UpIndex;

  TCM_QRPRogressUpdate = record
    Msg : Cardinal;
    Position : word;
    QRPrinter : TQRPrinter;
  end;

  TCM_QRPageAvailable = record
    Msg : Cardinal;
    PageCount : word;
    QRPrinter : TQRPrinter;
  end;

  TCM_QRPreviewClose = record
    Msg : Cardinal;
    Dummy : word;
    QRPrinter : TQRPrinter;
  end;

  TCM_QRPrint = TMessage;

  TCM_QRPRINTWITHSETUP = record
    Msg: Cardinal;
    Dummy: word;
    QRPrinter : TQRPrinter;
  end;

  TCM_QRREPREVIEW = record
    Msg: Cardinal;
    Dummy: word;
    QRPrinter : TQRPrinter;
  end;

  TCM_QRSWAPPRINTER = record
    Msg: Cardinal;
    OldQRPrinter,
    NewQRPrinter : TQRPrinter;
  end;

  { TQRExportFilterLibrary }
  TQRExportFilterClass = class of TQRExportFilter;

  TQRExportFilterLibraryEntry = class
  private
    FExportFilterClass : TQRExportFilterClass;
    FName : string;
    FExtension : string;
  public
    property ExportFilterClass : TQRExportFilterClass read FExportFilterClass write FExportFilterClass;
    property FilterName : string read FName write FName;
    property Extension : string read FExtension write FExtension;
  end;

  TQRExportFilterLibrary = class
  private
    FFilterList : TList;
  protected
    function GetSaveDialogFilter : string;
  public
    constructor Create;
    destructor Destroy; override;
    procedure AddFilter(AFilter : TQRExportFilterClass);
    procedure RemoveFilter(AFilter : TQRExportFilterClass);
    property Filters : TList read FFilterList;
    property SaveDialogFilterString : string read GetSaveDialogFilter;
  end;

  { TQRStream }
  TQRStream = class(TStream)
  private
    FLock: TRTLCriticalSection;
    MemoryStream : TMemoryStream;
    FFilename : string;
    FileStream : TFileStream;
    FInMemory : boolean;
    FMemoryLimit : longint;
  public
    constructor Create(MemoryLimit : Longint);
    constructor CreateFromFile(Filename : string);
    destructor Destroy; override;
    function Write(const Buffer; Count: Longint): Longint; override;
    function Seek(Offset: Longint; Origin: Word): Longint; override;
    function Read(var Buffer; Count: Longint): Longint; override;
    procedure LockStream;
    procedure UnlockStream;
    procedure SaveToStream(AStream : TStream);
    property InMemory : boolean read FInMemory;
  end;

  { TQRCompress }
  TQRCompress = class
  private
    BitPos : Byte;
    CompressFlag : Boolean;
    InByte : CodeType;
    Left, Right : TreeDownArray;
    OutByte : CodeType;
    Stream : TStream;
    Up : TreeUpArray;
    function GetByte : Byte;
    procedure InitializeSplay;
    procedure Splay(Plain : CodeType);
  public
    constructor Create(aStream : TStream; CompressData : boolean);
    destructor Destroy; override;
    procedure Expand(var Expanded : byte);
    procedure Compress(Plain : CodeType);
  end;

  { TQRPageList }
  TQRPageList = class
  private
    FLock: TRTLCriticalSection;
    aCompressor : TQRCompress;
    FCompression : boolean;
    FPageCount : integer;
    FStream : TQRStream;
    procedure SeekToFirst;
    procedure SeekToLast;
    procedure SeekToPage(PageNumber : integer);
    procedure ReadFileHeader;
    procedure WriteFileHeader;
  public
    constructor Create;
    destructor Destroy; override;
    function GetPage(PageNumber : integer) : TMetafile;
    procedure AddPage(aMetafile : TMetafile);
    procedure Clear;
    procedure Finish;
    procedure LoadFromFile(Filename : string);
    procedure LockList;
    procedure SaveToFile(Filename : string);
    procedure UnlockList;
    property Compression : boolean read FCompression write FCompression;
    property PageCount : integer read FPageCount;
    property Stream : TQRStream read FStream write FStream;
  end;

  { TQRPreviewInterface }
  TQRPreviewInterface = class(TComponent)
  public
//>RSV
    function Add(AQRPrinter: TQRPrinter) : TWinControl; virtual;
//<RSV
    function Show(AQRPrinter : TQRPrinter) : TWinControl; virtual;
    function ShowModal(AQRPrinter : TQRPrinter) : TWinControl; virtual;
  end;

  TQRPreviewInterfaceClass = class of TQRPreviewInterface;

  TQRStandardPreviewInterface = class(TQRPreviewInterface)
  public
//>RSV
    function Add(AQRPrinter: TQRPrinter) : TWinControl; override;
//<RSV
    function Show(AQRPrinter : TQRPrinter) : TWinControl; override;
    function ShowModal(AQRPrinter : TQRPrinter): TWinControl; override;
  end;

  { TQRPreviewImage }
  TQRZoomState = (qrZoomToFit,qrZoomToWidth,qrZoomOther);

  TQRPreviewImage = class(TGraphicControl)
  private
    FQRPrinter : TQRPrinter;
    FPageNumber : integer;
    aMetaFile : TMetafile;
    FImageOK : boolean;
    procedure PaintPage;
    procedure SetPageNumber(Value : integer);
//>RSV
    procedure SetQRPrinter(Value: TQRPrinter);
//<RSV
  protected
//>RSV
    procedure Notification(AComponent : TComponent; Operation : TOperation); override;
//<RSV
  public
    Zoom : Integer;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;
    property ImageOK : boolean read FImageOK write FImageOK;
    property PageNumber : integer read FPageNumber write SetPageNumber;
//    property QRPrinter : TQRPrinter read FQRPrinter write FQRPrinter;
    property QRPrinter : TQRPrinter read FQRPrinter write SetQRPrinter;
  end;

  { TQRPreview }
  TQRProgressUpdateEvent = procedure (Sender : TObject; Progress : integer) of object;

  TQRPageAvailableEvent = procedure (Sender : TObject; PageNum : integer) of object;

  TQRPrinterEvent = procedure (Sender: TObject; Printer: TQRPrinter) of object;
  TQRSwapPrinterEvent = procedure (Sender: TObject; OldPrinter, NewPrinter: TQRPrinter) of object;

  TQRPreview = Class(TScrollBox)
  private
    FOnPageAvailableEvent : TQRPageAvailableEvent;
    FOnProgressUpdateEvent : TQRProgressUpdateEvent;
    FPreviewImage : TQRPreviewImage;
    FPageNumber : integer;
//RSV    FQRPrinter : TQRPrinter;
    FZoom : integer;
    FZoomState : TQRZoomState;
//>RSV
    FPrinterList: TList;
//    FQRPrinterIndex: Integer;
    FOnSwapPrinter: TQRSwapPrinterEvent;
    FOnAddPrinter: TQRPrinterEvent;
    FOnRemovePrinter: TQRPrinterEvent;
//<RSV
    procedure SetPageNumber(Value : integer);
    procedure SetZoom(value : integer);
    procedure Fixvalues(Sender : TObject);
//         
    procedure SetQRPrinter(Value : TQRPrinter);
//>RSV
    function GetQRPrinter: TQRPrinter;
    function GetPrinterCount: Integer;
    function GetActivePrinterIndex: Integer;
    procedure SetActivePrinterIndex(Value: Integer);
    function GetQRPrinters(const Index: Integer): TQRPrinter;
    function GetTitle(const Index: Integer): String;
//<RSV
  protected
    procedure CMPageAvailable(var Message : TCM_QRPageAvailable); Message CM_QRPAGEAVAILABLE;
    procedure CMProgressUpdate(var Message : TCM_QRProgressUpdate); Message CM_QRPROGRESSUPDATE;
//>RSV
    procedure CMQRSWAPPRINTER(var Message : TCM_QRSWAPPRINTER); Message CM_QRSWAPPRINTER;
    procedure Notification(AComponent : TComponent; Operation : TOperation); override;
//<RSV
  public
    constructor Create(aOwner : TComponent); override;
    destructor Destroy; override;
//>RSV
    function Add(aQRPrinter: TQRPrinter): Integer;
    function Remove(aQRPrinter: TQRPrinter): Integer;
    function IndexOfPrinter(Value: TQRPrinter): Integer;
    procedure SwapPrinters(OldPrinter, NewPrinter: TQRPrinter);
    property PrintersCount: integer read GetPrinterCount;
    property ActivePrinterIndex: Integer read GetActivePrinterIndex write SetActivePrinterIndex;
    property QRPrinters[const Index: Integer]: TQRPrinter read GetQRPrinters;
    property ReportTitle[const Index: Integer]: String read GetTitle;
    property PrinterList: TList read FPrinterList;
    property OnSwapPrinter: TQRSwapPrinterEvent read FOnSwapPrinter write FOnSwapPrinter;
    property OnAddPrinter: TQRPrinterEvent read FOnAddPrinter write FOnAddPrinter;
    property OnRemovePrinter: TQRPrinterEvent read FOnRemovePrinter write FOnRemovePrinter;
//<RSV
    procedure UpdateImage;
    procedure UpdateZoom;
    procedure ZoomToWidth;
    procedure ZoomToFit;
    property PreviewImage : TQRPreviewImage read FPreviewImage;
//RSV    property QRPrinter : TQRPrinter read FQRPrinter write SetQRPrinter;
    property QRPrinter : TQRPrinter read GetQRPrinter write SetQRPrinter;
    property ZoomState : TQRZoomState read FZoomState write FZoomState;
  published
    property OnPageAvailable : TQRPageAvailableEvent read FOnPageAvailableEvent
                                                     write FOnPageAvailableEvent;
    property OnProgressUpdate : TQRProgressUpdateEvent read FOnProgressUpdateEvent write FOnProgressUpdateEvent;
    property PageNumber : integer read FPageNumber write setPageNumber;
    property Zoom : integer read FZoom write SetZoom;
  end;

  { TQRExportFilter }
  TQRExportFilter = class
  private
    FOriginalQRPrinter : TQRPrinter;
    FActive : boolean;
    FFilename : string;
    FOwner : TComponent;
  protected
    function GetDescription : string; virtual;
    function GetExtension : string; virtual;
    function GetFilterName : string; virtual;
    function GetVendorName : string; virtual;
    function GetStreaming : boolean; virtual;
  public
    constructor Create(Filename : string);
    procedure Start(PaperWidth, PaperHeight : integer; Font : TFont); virtual;
    procedure EndPage; virtual;
    procedure Finish; virtual;
    procedure NewPage; virtual;
    procedure TextOut(X,Y : extended; Font : TFont; BGColor : TColor; Alignment : TAlignment; Text : string); virtual;
    property Active : boolean read FActive write FActive;
    property Description : string read GetDescription;
    property FileExtension : string read GetExtension;
    property Filename : string read FFilename;
    property Name : string read GetFilterName;
    property Owner : TComponent read FOwner write FOwner;
    property Streaming : boolean read GetStreaming;
    property Vendor : string read GetVendorName;
    property OriginalQRPrinter : TQRPrinter read FOriginalQRPrinter write FOriginalQRPrinter;
  end;

  { TPrinterSettings }
  TPaperSizesSupported = array[Letter..Custom] of boolean;

  TPrinterSettings = class
  private
    { Device stuff }
    FDevice : PChar;
    FDriver : PChar;
    FPort : PChar;
    DeviceMode : THandle;
    DevMode : PDeviceMode;
    { Storage variables }
    FCopies : integer;
    FDuplex : boolean;
    FMaxExtentX : integer;
    FMaxExtentY : integer;
    FMinExtentX : integer;
    FMinExtentY : integer;
    FOrientation : TPrinterOrientation;
    FOutputBin : TQRBin;
    FPaperSize : TQRPaperSize;
    FPaperSizes : TPaperSizesSupported;
    FPaperWidth : integer;
    FPaperLength : integer;
    FPixelsPerX : integer;
    FPixelsPerY : integer;
    FTopOffset : integer;
    FLeftOffset : integer;
    FPrinter : TPrinter;
    FTitle : string;
    function GetCopies : integer;
    function GetDriver : string;
    function GetDuplex : boolean;
    function GetMaxExtentX : integer;
    function GetMaxExtentY : integer;
    function GetMinExtentX : integer;
    function GetMinExtentY : integer;
    function GetOrientation : TPrinterOrientation;
    function GetOutputBin : TQRBin;
    function GetPaperSize : TQRPaperSize;
    function GetPaperSizeSupported(PaperSize : TQRPaperSize) : boolean;
    function GetPaperWidth : integer;
    function GetPaperLength : integer;
    function GetPixelsPerX : integer;
    function GetPixelsPerY : integer;
    function GetPort : string;
    function GetPrinter : TPrinter;
    function GetTitle : string;
    function GetTopOffset : integer;
    function GetLeftOffset : integer;
    function Supported(Setting : integer) : boolean;
    procedure SetField(aField : integer);
    procedure GetPrinterSettings;
    procedure SetCopies(Value : integer);
    procedure SetDuplex(Value : boolean);
    procedure SetOrientation(Value : TPrinterOrientation);
    procedure SetOutputBin(Value : TQRBin);
    procedure SetPaperSize(Value : TQRPaperSize);
    procedure SetPaperLength(Value : integer);
    procedure SetPaperWidth(Value : integer);
    procedure SetPrinter(Value : TPrinter);
    procedure SetTitle(Value : string);
  public
    constructor Create;
    destructor Destroy; override;
    procedure ApplySettings;
    { read only properties }
    property Device : string read GetDriver;
    property Driver : string read GetDriver;
    property LeftOffset : integer read GetLeftOffset;
    property MaxExtentX : integer read GetMaxExtentX;
    property MaxExtentY : integer read GetMaxExtentY;
    property MinExtentX : integer read GetMinExtentX;
    property MinExtentY : integer read GetMinExtentY;
    property PaperSizeSupported[PaperSize : TQRPaperSize] : boolean read GetPaperSizeSupported;
    property PixelsPerX : integer read GetPixelsPerX;
    property PixelsPerY : integer read GetPixelsPerY;
    property Port : string read GetPort;
    property TopOffset : integer read GetTopOffset;
    { Read/write properties }
    property Copies : integer read GetCopies write SetCopies default 1;
    property Duplex : boolean read GetDuplex write SetDuplex default False;
    property Orientation : TPrinterOrientation read GetOrientation write SetOrientation default poPortrait;
    property OutputBin : TQRBin read GetOutputBin write SetOutputBin default Auto;
    property PaperLength : integer read GetPaperLength write SetPaperLength;
    property PaperSize : TQRPaperSize read GetPaperSize write SetPaperSize default A4;
    property PaperWidth : integer read GetPaperWidth write SetPaperWidth;
    property Printer : TPrinter read GetPrinter write SetPrinter;
    property Title : string read GetTitle write SetTitle;
  end;

  { TQRPrinterSettings }
  TQRPrinterSettings = class(TPersistent)
  private
    FCopies : integer;
    FDuplex : boolean;
    FOrientation : TPrinterOrientation;
    FOutputBin : TQRBin;
    FPaperSize : TQRPaperSize;
    FPrinterIndex : integer;
    FTitle : string;
    FFirstPage : integer;
    FLastPage : integer;
  public
    constructor Create;
    procedure ApplySettings(APrinter : TQRPrinter);
    property Copies : integer read FCopies write FCopies default 1;
    property Duplex : boolean read FDuplex write FDuplex default false;
    property FirstPage : integer read FFirstPage write FFirstPage default 0;
    property LastPage : integer read FLastPage write FLastPage default 0;
    property Orientation : TPrinterOrientation read FOrientation write FOrientation  default poPortrait;
    property OutputBin : TQRBin read FOutputBin write FOutputBin default Auto;
    property PaperSize : TQRPaperSize read FPaperSize write FPaperSize default A4;
    property PrinterIndex : integer read FPrinterIndex write FPrinterIndex;
    property Title : string read FTitle write FTitle;
  end;

  { TQRPrinter related declarations }

  TQRPrinterDestination = (qrdMetafile, qrdPrinter);

  TQRPrinterStatus = (mpReady, mpBusy, mpFinished);

  TQRGenerateToPrinterEvent = procedure of object;
  TQRPrintSetupEvent = procedure of object;
  TQRPrintWithSetupEvent = procedure (var Enabled: Boolean) of object;
  TQRExportToFilterEvent = procedure (aFilter : TQRExportFilter) of object;
  TQRPreviewEvent = procedure of object;
  TQRAfterPrintEvent = procedure (Sender : TObject) of object;
  TQRAfterPreviewEvent = procedure (Sender : TObject) of object;

  { TQRPrinter }
//RSV  TQRPrinter = class(TPersistent)
//  TComponent
//RSV  TQRPrinter = class(TPersistent)
  TQRPrinter = class(TComponent)
  private
    aPrinter : TPrinter;
    aPrinterSettings : TPrinterSettings;
    aStream : TQRStream;
    FAfterPrintEvent : TQRAfterPrintEvent;
    FAfterPreviewEvent : TQRAfterPreviewEvent;
    FAvailablePages : integer;
    FCancelled : boolean;
    FCanvas : TCanvas;
    FCloseControl : TWinControl;
    FDestination : TQRPrinterDestination;
    FFirstPage : integer;
    FLastpage : integer;
    FLeftWaste : integer;
    FClient : TWinControl;
    FMaster : TWinControl;
    FMetafile : TMetafile;
    FOnExportToFilterEvent : TQRExportToFilterEvent;
    FOnPreviewEvent : TNotifyEvent;
    FOnPrintSetupEvent : TQRPrintSetupEvent;
//>RSV
    FOnPrintWithSetupEvent : TQRPrintWithSetupEvent;
//<RSV
    FPage : TMetafile;
    FPageCount : integer;
    FPageNumber : integer;
    FPrinterOK : boolean;
    FProgress : integer;
    FTitle : string;
    FTopWaste : integer;
    FShowingPreview : boolean;
    FStatus : TQRPrinterStatus;
    FXFactor : extended;
    FYFactor : extended;
    PageList : TQRPageList;
//RSV    PreviewControl : TWinControl;
    FPreviewControl : TWinControl;
    FReportLoaded : boolean;
//>RSV
    procedure SetPreviewControl(Value: TWinControl);
//<RSV
    function CurrentPageOK : boolean;
    function GetLeftWaste : integer;
    function GetBin : TQRBin;
    function GetCanvas : TCanvas;
    function GetCompression : boolean;
    function GetCopies : integer;
    function GetDuplex : boolean;
    function GetOrientation : TPrinterOrientation;
    function GetPaperLength : integer;
    function GetPaperSize : TQRPaperSize;
    function GetPaperWidth : integer;
    function GetPrinterIndex : integer;
    function GetPrinters : TStrings;
    function GetTopWaste : integer;
    procedure CreateMetafileCanvas;
    procedure CreatePrinterCanvas;
    procedure EndMetafileCanvas;
    procedure EndPrinterCanvas;
    procedure SetAvailablePages(Value : integer);
    procedure SetBin(Value : TQRBin);
    procedure SetCompression(Value : boolean);
    procedure SetCopies(Value : integer);
    procedure SetDestination(Value : TQRPrinterDestination);
    procedure SetDuplex(Value : boolean);
    procedure SetOrientation(Value : TPrinterOrientation);
    procedure SetPaperLength(Value : integer);
    procedure SetPageNumber(Value : integer);
    procedure SetPaperSize(Value : TQRPaperSize);
    procedure SetPaperWidth(Value : integer);
    procedure SetPrinterIndex(Value : integer);
    procedure SetProgress(Value : integer);
    procedure SetShowingPreview(Value : boolean);
//>RSV
    function GetMaster: TWinControl;
    procedure SetMaster(Value: TWinControl);
//<RSV
  protected
//    PageList : TQRPageList;
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
//>RSV
    procedure DoAfterPreview;
    procedure DoAfterPrint;
//<RSV
  public
//RSV    constructor Create;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function GetPage(Value : integer) : TMetafile;
    function XPos(Value : extended) : integer;
    function XSize(Value : extended) : integer;
    function YPos(Value : extended) : integer;
    function YSize(Value : extended) : integer;
    function PaperLengthValue : integer;
    function PaperWidthValue : integer;
    procedure AbortDoc;
    procedure BeginDoc;
    procedure Cancel;
    procedure Cleanup;
    procedure ClosePreview(Control : TWinControl);
    procedure EndDoc;
    procedure ExportToFilter(aFilter : TQRExportFilter);
    procedure Load(Filename : string);
    procedure NewPage;
    procedure Preview;
    procedure PreviewModal;
//>RSV
    procedure AddToPreview;
    procedure RePreview;
    procedure Swap(NewPrinter: TQRPrinter);
//<RSV
    procedure Print;
    procedure PrintSetup;
    procedure PrintWithSetup;
    procedure Save(Filename : string);
//>RSV
    property PreviewControl: TWinControl read FPreviewControl write SetPreviewControl;
//<RSV
    property ReportLoaded : boolean read FReportLoaded write FReportLoaded;
    property AfterPreview : TQRAfterPreviewEvent read FAfterPreviewEvent write FAfterPreviewEvent;
    property AfterPrint : TQRAfterPrintEvent read FAfterPrintEvent write FAfterPrintEvent;
    property AvailablePages : integer read FAvailablePages write SetAvailablePages;
    property OutputBin : TQRBin read GetBin write SetBin;
    property Cancelled : boolean read FCancelled write FCancelled;
    property Canvas : TCanvas read GetCanvas;
    property Client : TWinControl read FClient write FClient;
    property Compression : boolean read GetCompression write SetCompression;
    property Copies : integer read GetCopies write SetCopies;
    property Destination : TQRPrinterDestination read FDestination write SetDestination;
    property Duplex : boolean read GetDuplex write SetDuplex;
    property FirstPage : integer read FFirstPage write FFirstPage;
    property LastPage : integer read FLastPage write FLastPage;
    property LeftWaste : integer read GetLeftWaste;
//    property Master : TWinControl read FMaster write FMaster;
    property Master : TWinControl read GetMaster write SetMaster;
    property Orientation : TPrinterOrientation read GetOrientation write SetOrientation;
    property OnExportToFilter : TQRExportToFilterEvent read FOnExportToFilterEvent
                                                       write FOnExportToFilterEvent;
    property OnPreview : TNotifyEvent read FOnPreviewEvent write FOnPreviewEvent;
    property OnPrintSetup : TQRPrintSetupEvent read FOnPrintSetupEvent write FOnPrintSetupEvent;
    property OnPrintWithSetup : TQRPrintWithSetupEvent read FOnPrintWithSetupEvent write FOnPrintWithSetupEvent;
    property PaperLength : Integer read GetPaperLength write SetPaperLength;
    property Page : TMetafile read FPage;
    property PageCount : integer read FPageCount write FPageCount;
    property PageNumber : Integer read FPageNumber write SetPageNumber;
    property PaperWidth : Integer read GetPaperWidth write SetPaperWidth;
    property PaperSize : TQRPaperSize read GetPaperSize write SetPaperSize;
    property PrinterIndex : integer read GetPrinterIndex write SetPrinterIndex;
    property PrinterOK : boolean read FPrinterOK;
    property Printers : TStrings read GetPrinters;
//>RSV
    property CurrentPrinter : TPrinter read aPrinter;
//<RSV
    property Progress : integer read FProgress write SetProgress;
    property ShowingPreview : boolean read FShowingPreview write SetShowingPreview;
    property Status : TQRPrinterStatus read FStatus;
    property Title : string read FTitle write FTitle;
    property TopWaste : integer read GetTopWaste;
    property XFactor : extended read FXFactor write FXFactor;
    property YFactor : extended read FYFactor write FYFactor;
  end;

  TQRPrinterClass = class of TQRPrinter;

  function GetFonts : TStrings;

  function TempFilename : string;
  function QRPaperName(Size : TQRPaperSize) : string;

  procedure RegisterPreviewClass(APreviewInterface : TQRPreviewInterfaceClass);

  function QRPrinter : TQRPrinter;

  function GlobalQRPrinterPool: TQRPrinterPool;

var
  QRExportFilterLibrary : TQRExportFilterLibrary;

procedure ClearGlobalPreview(aComponent: TComponent);

var
  QRPrintersPool: TQRPrinterPool;

implementation

uses
  rPrevQR;//QRPrev;

var
  FQRPrinter : TQRPrinter;
  GlobalPreviewInterface : TQRPreviewInterfaceClass;

const
  cQRPFormatVersion = 3;

type
  TQRFileHeader = record
    FormatVersion : word;                   { File format version }
    QRVersion : word;                       { QR version }
    PageSize : TQRPaperSize;
    PageCount : integer;
    CreateDateTime : TDateTime;
    Portrait : boolean;                     { field added in header version 2 }
    Compression : byte;                     { 0 - no compression, 1 - splay }
    EmptySpace : array[0..100] of byte;
  end;

//>RSV

const
  QRWindowState: Array[TWindowState] of Integer = (SW_SHOW, SW_RESTORE, SW_MAXIMIZE);

var
  GlobalQRPreview: TrNewQRPreview;

function GlobalQRPrinterPool: TQRPrinterPool;
begin
  Result := QRPrintersPool;
end;

procedure ClearGlobalPreview(aComponent: TComponent);
begin
  if aComponent = GlobalQRPreview then GlobalQRPreview := nil;
end;

function CreateStandardPreview: TrNewQRPreview;
begin
  if not Assigned(GlobalQRPreview)
  then if Application.MainForm <> nil
    then GlobalQRPreview := TrNewQRPreview.Create(Application.MainForm)
    else GlobalQRPreview := TrNewQRPreview.Create(Application);
  Result := GlobalQRPreview;
end;
//<RSV

{$ifdef EvalVersion}
function DelphiRunning : boolean;
var
  H1, H2, H3, H4 : Hwnd;
const
  A1 : array[0..12] of char = 'TApplication'#0;
  A2 : array[0..15] of char = 'TAlignPalette'#0;
  A3 : array[0..18] of char = 'TPropertyInspector'#0;
  A4 : array[0..11] of char = 'TAppBuilder'#0;
  T1 : array[0..6] of char = 'Delphi'#0;
begin
  H2 := FindWindow(A2, nil);
  H3 := FindWindow(A3, nil);
  H4 := FindWindow(A4, nil);
  Result := (H2 <> 0) and
            (H3 <> 0) and (H4 <> 0);
end;
{$endif}

function QRPHeaderSize(const Stream : TStream ) : integer;
var
  OldPosition : Integer;
  Buf : array[0..3] of Char;
  FoundSize : boolean;
begin
  // Assert parameters
  Assert(Assigned(Stream));

  // Check for the EMF header.  In versions previous to Delphi 5, the
  // string EMF will be found at $AD.
  OldPosition := Stream.Position;
  try
    Stream.Position := $ad;
    Stream.ReadBuffer(Buf, 4);
    FoundSize := (Buf = 'EMF');
    result := 124;

    if not FoundSize then begin
      result := 128;
      Stream.Position := $B1;
      Stream.ReadBuffer( Buf, 4 );
      FoundSize := (Buf = 'EMF');
    end;
    if not FoundSize then
      Result := SizeOf(TQRFileHeader);
  finally
    Stream.Position := OldPosition;
  end;
end;

{$ifdef BFQR_D5}
function GetFileHeaderSize( const Stream: TStream ): Integer;
begin
  // Assert parameters
  Assert( Assigned( Stream ) );

  // Determine size of header
  result := QRPHeaderSize(Stream);
end; // function GetFileHeaderSize
procedure FixupFileHeader( const Stream: TStream; var aFileHeader: TQRFileHeader );
type
  TQRD4FileHeader = packed record           // Packed to have full control over alignment
    FormatVersion : word;                   { File format version }
    QRVersion : word;                       { QR version }
    PageSize : TQRPaperSize;
    Reserved1 : array[ 0..2 ] of Byte;      // Fixup to match delphi 4 record alignment
    PageCount : integer;
    CreateDateTime : TDateTime;
    Portrait : boolean;                     { field added in header version 2 }
    Compression : byte;                     { 0 - no compression, 1 - splay }
    EmptySpace : array[0..100] of byte;
  end;
var
  D4FileHeader  : TQRD4FileHeader;
  {MySize,} FileSize: integer;
begin
  // Assert parameters
  Assert( Assigned( Stream ) );

  FileSize := GetFileHeaderSize(Stream);

  // Now do the fixup, if necessary
  if FileSize = 124 then begin
    Move( aFileHeader, D4FileHeader, 124 ); // Move record into old format record

    // Now copy values field by field
    aFileHeader.FormatVersion := D4FileHeader.FormatVersion;
    aFileHeader.QRVersion := D4FileHeader.QRVersion;
    aFileHeader.PageSize := D4FileHeader.PageSize;
    aFileHeader.PageCount := D4FileHeader.PageCount;
    aFileHeader.CreateDateTime := D4FileHeader.CreateDateTime;
    aFileHeader.Portrait := D4FileHeader.Portrait;
    aFileHeader.Compression := D4FileHeader.Compression;
    Move( D4FileHeader.EmptySpace, aFileHeader.EmptySpace, 101 );
  end;
end; // procedure FixupFileHeader
{$else}
function GetFileHeaderSize( const Stream: TStream ): Integer;
begin
  Result := SizeOf(TQRFileHeader);
end; // function GetFileHeaderSize
procedure FixupFileHeader( const Stream: TStream; var aFileHeader: TQRFileHeader );
begin
end;
{$endif}
// QR306005 end


function QRPaperName(Size : TQRPaperSize) : string;
const
  Names : array[Default..Custom] of string = (
   SqrPaperSize0, SqrPaperSize1, SqrPaperSize2, SqrPaperSize3,
   SqrPaperSize4, SqrPaperSize5, SqrPaperSize6, SqrPaperSize7,
   SqrPaperSize8, SqrPaperSize9, SqrPaperSize10, SqrPaperSize11,
   SqrPaperSize12, SqrPaperSize13, SqrPaperSize14, SqrPaperSize15,
   SqrPaperSize16, SqrPaperSize17, SqrPaperSize18, SqrPaperSize19,
   SqrPaperSize20, SqrPaperSize21, SqrPaperSize22, SqrPaperSize23,
   SqrPaperSize24, SqrPaperSize25, SqrPaperSize26, SqrPaperSize27,
//>RSV
   SqrPaperSize28, SqrPaperSize29, SqrPaperSize30, SqrPaperSize31,
   SqrPaperSize32, SqrPaperSize33, SqrPaperSize34, SqrPaperSize35,
   SqrPaperSize36, SqrPaperSize37, SqrPaperSize38, SqrPaperSize39,
   SqrPaperSize40, SqrPaperSize41, SqrPaperSize42, SqrPaperSize43
//<RSV
   );

begin
  Result := Names[Size];
end;

function TempFilename : string;
var
  AName,
  ADir : array[0..255] of char;
begin
  GetTempPath(255, adir);
  GetTempFilename(aDir, PChar('QRP'), 0, aName);
  result := StrPas(aName);
end;

{ TQRStream }

constructor TQRStream.Create(MemoryLimit : longint);
begin
  inherited Create;
{RSV
  FInMemory := true;
  MemoryStream := TMemoryStream.Create;
  FMemoryLimit := MemoryLimit;
}
  FInMemory := MemoryLimit > 0;
  if FInMemory then MemoryStream := TMemoryStream.Create
  else begin
    FFilename := TempFilename;
    FileStream := TFileStream.Create(FFilename, fmCreate or fmOpenReadWrite);
  end;
  FMemoryLimit := MemoryLimit;

  InitializeCriticalSection(FLock);
end;

constructor TQRStream.CreateFromFile(Filename : string);
begin
  inherited Create;
  FInMemory := false;
  FileStream := TFileStream.Create(Filename, fmOpenRead + fmShareDenyNone);
  FMemoryLimit := 0;
  InitializeCriticalSection(FLock);
end;

destructor TQRStream.Destroy;
begin
  LockStream;
  try
    if InMemory then
      MemoryStream.Free
    else
    begin
      FileStream.Free;
      DeleteFile(FFilename);
    end;
  finally
    UnlockStream;
    DeleteCriticalSection(FLock);
  end;
  inherited Destroy;
end;

procedure TQRStream.LockStream;
begin
  EnterCriticalSection(FLock);
end;

procedure TQRStream.UnlockStream;
begin
  LeaveCriticalSection(FLock);
end;

function TQRStream.Write(const Buffer; Count: Longint): Longint;
begin
  LockStream;
  if InMemory then
  begin
    result := MemoryStream.Write(Buffer,Count);
    if MemoryStream.Size > FMemoryLimit then {...this could be optimized somewhat }
    begin
      FFilename := TempFilename;
      FileStream := TFileStream.Create(FFilename, fmCreate or fmOpenReadWrite);
      MemoryStream.SaveToStream(FileStream);
      MemoryStream.Free;
      FInMemory := false;
    end
  end else
    result := FileStream.Write(Buffer,Count);
  UnlockStream;
end;

function TQRStream.Read(var Buffer; Count: Longint): Longint;
begin
  LockStream;
  if InMemory then
    result := MemoryStream.Read(Buffer,Count)
  else
    result := FileStream.Read(Buffer,Count);
  UnlockStream;
end;

function TQRStream.Seek(Offset: Longint; Origin: Word): Longint;
begin
  LockStream;
  if InMemory then
    result := MemoryStream.Seek(Offset,Origin)
  else
    result := FileStream.Seek(Offset,Origin);
  UnlockStream;
end;

procedure TQRStream.SaveToStream(AStream : TStream);
var
  Buffer : array[0..10240] of byte;
  BytesRead : longint;
begin
  LockStream;
  Position := 0;
  repeat
    BytesRead := Read(Buffer,10240);
    AStream.Write(Buffer,BytesRead);
  until BytesRead=0;
  UnlockStream;
end;

{ TQRCompress }

constructor TQRCompress.Create(aStream : TStream; CompressData : boolean);
begin
  Stream := aStream;
  InitializeSplay;
  if CompressData then
    BitPos := 0
  else
    BitPos := 7;
  OutByte := 0;
  CompressFlag := CompressData;
end;

destructor TQRCompress.Destroy;
begin
  if CompressFlag and (BitPos<>0) then
    Stream.Write(OutByte,1);
  inherited Destroy;
end;

procedure TQRCompress.InitializeSplay;
var
  I : DownIndex;
  J : UpIndex;
  K : DownIndex;
begin
  for I := 1 to TwiceMax do
    Up[I] := (I-1) shr 1;
  for J := 0 to PredMax do
  begin
    K := (J+1) shl 1;
    Left[J] := K-1;
    Right[J] := K;
  end;
end;

procedure TQRCompress.Splay(Plain : CodeType);
var
  A, B : DownIndex;
  C, D : UpIndex;
begin
  A := Plain+MaxChar;
  repeat
    C := Up[A];
    if C <> ROOT then
    begin
      D := Up[C];
      B := Left[D];
      if C = B then
      begin
        B := Right[D];
        Right[D] := A;
      end else
        Left[D] := A;
      if A = Left[C] then
        Left[C] := B
      else
        Right[C] := B;
      Up[A] := D;
      Up[B] := C;
      A := D;
    end else
      A := C;
  until A = ROOT;
end;

procedure TQRCompress.Compress(Plain : CodeType);
{ Compress a single byte }
var
  A : DownIndex;
  U : UpIndex;
  Sp : 0..MaxChar;
  Stack : array[UpIndex] of Boolean;
begin
  A := Plain+MaxChar;
  Sp := 0;
  repeat
    U := Up[A];
    Stack[Sp] := (Right[U] = A);
    inc(Sp);
    A := U;
  until A = ROOT;
  repeat
    dec(Sp);
    if Stack[Sp] then
      OutByte := OutByte or BitMask[BitPos];
    if BitPos = 7 then
    begin
      Stream.Write(OutByte, 1); { writebyte }
      BitPos := 0;
      OutByte := 0;
    end else
      inc(BitPos);
  until Sp = 0;
  Splay(Plain);
end;

function TQRCompress.GetByte : Byte;
begin
  Stream.Read(Result, 1);
end;

procedure TQRCompress.Expand(var Expanded : byte);
{ Expand a single byte }
var
  A : DownIndex;
begin
  A := ROOT;
  repeat
    if BitPos = 7 then
    begin
      InByte := GetByte;
      BitPos := 0;
    end else
      inc(BitPos);
    if InByte and BitMask[BitPos] = 0 then
      A := Left[A]
    else
      A := Right[A];
  until A > PredMax;
  dec(A, MaxChar);
  Splay(A);
  Expanded := A;
end;

{ TQRPageList }

constructor TQRPageList.Create;
begin
  inherited Create;
  FPageCount := 0;
  FCompression := false;
  FStream := nil;
  InitializeCriticalSection(FLock);
end;

destructor TQRPageList.Destroy;
begin
  DeleteCriticalSection(FLock);
  if assigned(FStream) then
  begin
    FStream.Free;
    FStream := nil;
  end;
  inherited Destroy;
end;

procedure TQRPageList.Clear;
begin
  FPageCount := 0;
end;

procedure TQRPageList.LockList;
begin
  EnterCriticalSection(FLock);
end;

procedure TQRPageList.UnlockList;
begin
  LeaveCriticalSection(FLock);
end;

procedure TQRPageList.Finish;
begin
  WriteFileHeader;
end;

procedure TQRPageList.LoadFromFile;
begin
  if assigned(FStream) then
    Stream.Free;
  Stream := TQRStream.CreateFromFile(Filename);
  ReadFileHeader;
end;

procedure TQRPageList.SaveToFile(Filename : string);
var
  AStream : TFileStream;
begin
  AStream := TFileStream.Create(Filename,fmCreate or fmOpenReadWrite);
  Stream.SaveToStream(AStream);
  AStream.Free;
end;

procedure TQRPageList.SeekToFirst;
begin
  Stream.Position := GetFileHeaderSize( Stream );
end;

procedure TQRPageList.SeekToLast;
var
  PrevPosition : longint;
begin
  Stream.Seek(-SizeOf(PrevPosition), soFromEnd);
  Stream.Read(PrevPosition,SizeOf(PrevPosition));
  Stream.Position := PrevPosition;
end;

procedure TQRPageList.SeekToPage(PageNumber : integer);
var
  ThisPageNum : longint;
  NextPosition : longint;
  PrevPosition : longint;
begin
  if PageNumber = 1 then
    SeekToFirst
  else
    if PageNumber = PageCount then
      SeekToLast
    else
    begin
      if Stream.Position = Stream.Size then
        SeekToLast;
      Stream.Read(ThisPageNum, SizeOf(ThisPageNum));
      Stream.Seek(-SizeOf(ThisPageNum), soFromCurrent);
      if ThisPageNum<PageNumber then
      begin
        repeat
          Stream.Read(ThisPageNum, SizeOf(ThisPageNum));
          if ThisPageNum<>PageNumber then
          begin
            Stream.Read(NextPosition, SizeOf(NextPosition));
            Stream.Position := NextPosition;
          end;
        until ThisPageNum=PageNumber;
        Stream.Seek(-SizeOf(ThisPageNum), soFromCurrent);
      end else
        if ThisPageNum>PageNumber then
        begin
          repeat
            Stream.Read(ThisPageNum,SizeOf(ThisPageNum));
            if ThisPageNum<>PageNumber then
            begin
              Stream.Position := Stream.Position - SizeOf(PrevPosition) - SizeOf(ThisPageNum);
              Stream.Read(PrevPosition,SizeOf(PrevPosition));
              Stream.Position := PrevPosition;
            end;
          until ThisPageNum=PageNumber;
          Stream.Seek(-SizeOf(ThisPageNum), soFromCurrent);
        end;
    end;
end;

function TQRPageList.GetPage(PageNumber : integer) : TMetafile;
var
  Dummy : longint;
  TempStream : TMemoryStream;
  aByte : byte;
  BytesToGet : longint;
  I : longint;
begin
  if PageNumber > PageCount then
    result := nil
  else
  try
    LockList;
    SeekToPage(PageNumber);
    Stream.Read(Dummy,SizeOf(Dummy));
    Stream.Read(Dummy,SizeOf(Dummy));
    BytesToGet := BytesToGet-Stream.Position;
    result := TMetafile.Create;
    if Compression then
    begin
      Stream.Read(BytesToGet,SizeOf(BytesToGet));
      TempStream := TMemoryStream.Create;
      aCompressor := TQRCompress.Create(Stream, false);
      for I := 1 to BytesToGet do
      begin
        aCompressor.Expand(aByte);
        TempStream.Write(aByte,1);
      end;
      aCompressor.Free;
      TempStream.Position := 0;
      result.LoadFromStream(TempStream);
      TempStream.Free;
    end else
      result.LoadFromStream(Stream);
    Stream.Read(Dummy, SizeOf(Dummy));
  finally
    UnlockList;
  end;
end;

procedure TQRPageList.ReadFileHeader;
var
  aFileHeader : TQRFileHeader;
begin
  Stream.Position := 0;
  Stream.Read(aFileHeader, GetFileHeaderSize(Stream));
  FixupFileHeader(Stream, aFileHeader);
  FPageCount := aFileHeader.PageCount;
end;

procedure TQRPageList.WriteFileHeader;
var
  aFileHeader : TQRFileHeader;
begin
  Stream.Position := 0;
  aFileHeader.FormatVersion := cQRPFormatVersion;
  aFileHeader.QRVersion := cQRVersion;
  aFileHeader.PageCount := PageCount;
  aFileHeader.CreateDateTime := Now;
  if Compression then
    aFileHeader.Compression := 1
  else
    aFileHeader.Compression := 0;
  Stream.Write(aFileHeader, SizeOf(aFileHeader));
end;

procedure TQRPageList.AddPage(aMetafile : TMetafile);
var
  I,
  SavePos1,
  SavePos2,
  SavePos3 : longint;
  TempStream : TMemoryStream;
  aByte : byte;

  procedure SavePreInfo;
  var
    aPageCount : longint;
  begin
    aPageCount := FPageCount;
    Stream.Position := Stream.Size;
    SavePos1 := Stream.Position;                    { Store start position }
    Stream.Write(aPageCount, SizeOf(aPageCount));   { Write page number }
    SavePos2 := Stream.Position;                    { Store metafile size pos }
    Stream.Write(SavePos2, SizeOf(SavePos2));       { Reserve space for size }
  end;

  procedure SavePostInfo;
  begin
    Stream.Write(SavePos1, Sizeof(SavePos1));       { Store previous start }
    SavePos3 := Stream.Position;                    { Store post of next }
    Stream.Position := SavePos2;                    { Go back to reserved pos }
    Stream.Write(SavePos3, Sizeof(SavePos3));       { Save pos of next};
    Stream.Position := SavePos3;                    { Go to end of stream }
  end;

begin
  try
    LockList;
    inc(FPageCount);
    if PageCount = 1 then
      WriteFileHeader;
    if Compression then
    begin
      TempStream := TMemoryStream.Create;
      AMetafile.SaveToStream(TempStream);
      SavePreInfo;
      aCompressor := TQRCompress.Create(Stream,true);
      TempStream.Position := 0;
      I := TempStream.Size;
      Stream.Write(I,SizeOf(I));
      for I := 0 to TempStream.Size - 1 do
      begin
        TempStream.Read(aByte,1);
        aCompressor.Compress(aByte);
      end;
      aCompressor.Free;
      TempStream.Free;
      SavePostInfo;
    end else
    begin
      SavePreInfo;
      AMetaFile.SaveToStream(Stream);               { Save the metafile }
      SavePostInfo;
    end;
  finally
    UnlockList;
  end;
end;

function QREnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
                       FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
end;

function GetFonts : TStrings;
begin
  if Printer.Printers.Count = 0 then
    Result := Screen.Fonts
  else
    Result := Printer.Fonts;
end;

{ TQRPreviewInterface }

function TQRPreviewInterface.Add(AQRPrinter: TQRPrinter): TWinControl;
begin
  Result := nil;  //RAA
end;

function TQRPreviewInterface.Show(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := nil;  //RAA
end;

function TQRPreviewInterface.ShowModal(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := nil;  //RAA
end;
{RSV
function TQRStandardPreviewInterface.Add(AQRPrinter: TQRPrinter): TWinControl;
begin
//
end;

function TQRStandardPreviewInterface.Show(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := TQRStandardPreview.CreatePreview(Application, AQRPrinter);
  TQRStandardPreview(Result).Show;
end;

function TQRStandardPreviewInterface.ShowModal(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := TQRStandardPreview.CreatePreview(Application, AQRPrinter);
  TQRStandardPreview(Result).ShowModal;
end;
}
function TQRStandardPreviewInterface.Add(AQRPrinter: TQRPrinter): TWinControl;
begin
  Result := CreateStandardPreview;
  if Assigned(Result) then
    TrNewQRPreview(Result).Add(AQRPrinter);
end;
//QRWindowState

function TQRStandardPreviewInterface.Show(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := CreateStandardPreview;
  if Assigned(Result) then begin
    TrNewQRPreview(Result).Add(AQRPrinter);
    TCustomForm(Result).Show;
    ShowWindowAsync(Result.Handle,QRWindowState[TCustomForm(Result).WindowState]);
    BringWindowToTop(Result.Handle);
  end;
end;

function TQRStandardPreviewInterface.ShowModal(AQRPrinter : TQRPrinter) : TWinControl;
begin
  Result := CreateStandardPreview;
  if Assigned(Result) then begin
    TrNewQRPreview(Result).Add(AQRPrinter);
    if IsWindowVisible(Result.Handle)
    then Result.Hide;
    TCustomForm(Result).ShowModal;
  end;
end;

{ TQRPreviewImage }

constructor TQRPreviewImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Height := 50;
  Width := 100;
  Zoom := 100;
  QRPrinter := nil;
  ImageOK := false;
  FPageNumber := 1;
end;

destructor TQRPreviewImage.Destroy;
begin
  if ImageOK then aMetafile.Free;
  aMetafile := nil;  
  FQRPrinter := nil;
  inherited Destroy;
end;

procedure TQRPReviewImage.PaintPage;
begin
  { Paint page background }
  if ImageOK or (csDesigning in ComponentState) then
    with Canvas do
    begin
      Brush.Color := clWhite;
      Pen.Color := clWhite;
      Rectangle(1, 1, Width - cQRPageFrameWidth - cQRPageShadowWidth, Height - cQRPageFrameWidth - cQRPageShadowWidth);
    end;
  if ImageOK then
  begin
    { Paint the metafile }
    Canvas.StretchDraw(rect(0, 0, Width, Height),aMetafile);
  end;
  { Paint frame around page }
  if ImageOK or (csDesigning in ComponentState) then
    with Canvas do
    begin
      Pen.Color := cQRPageShadowColor;
      Pen.Width := cQRPageFrameWidth;
      MoveTo(0,0);
      LineTo(0,Height - cQRPageFrameWidth - cQRPageShadowWidth);
      LineTo(Width - cQRPageFrameWidth - cQRPageShadowWidth, Height - cQRPageFrameWidth - cQRPageShadowWidth);
      LineTo(Width - cQRPageFrameWidth - cQRPageShadowWidth, 0);
      LineTo(0, 0);
      Brush.Color := cQRPageShadowColor;
      Rectangle(Width - cQRPageShadowWidth, cQRPageShadowWidth, Width, Height);
      Rectangle(cQRPageShadowWidth, Height - cqrPageShadowWidth, Width, Height);
    end;
end;

procedure TQRPreviewImage.Paint;
begin
  PaintPage;
end;

procedure TQRPreviewImage.SetPageNumber(Value : integer);
begin
  FPageNumber := Value;
  if assigned(aMetafile) then
    aMetafile.Free;
  aMetaFile := nil;
  if assigned(FQRPrinter) then
    aMetaFile := QRPrinter.GetPage(Value);
  ImageOK := aMetafile <> nil;
  PaintPage;
end;

procedure TQRPreviewImage.SetQRPrinter(Value: TQRPrinter);
begin
  if Value <> FQRPrinter then begin
    FQRPrinter := Value;
    if Assigned(Value) then FreeNotification(Value);
  end;
end;

procedure TQRPreviewImage.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
    if AComponent = QRPrinter then QRPrinter := nil;
  end;
end;

{ TQRPreview }

constructor TQRPreview.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FPreviewImage := TQRPreviewImage.Create(self);
  FPreviewImage.Parent := self;
  with FPreviewImage do
  begin
    Top := 0;
    Left := 0;
  end;
  HorzScrollbar.Tracking := true;
  VertScrollBar.Tracking := true;
  FZoom := 100;
//  FQRPrinter := nil;
  ZoomState := qrZoomOther{qrDefaultZoom};
  OnResize := FixValues;
  Height := 250;
  Width := 250;
  FPageNumber := 1;
  FOnPageAvailableEvent := nil;
  FOnProgressUpdateEvent := nil;

  FOnSwapPrinter  := nil;
  FOnAddPrinter   := nil;
  FOnRemovePrinter:= nil;

  FPrinterList := TList.Create;
end;

destructor TQRPreview.Destroy;
var
  I: Integer;
begin
  if FPrinterList.Count > 0 then
  for I := 0 to FPrinterList.Count-1 do
    TQRPrinter(FPrinterList.Items[I]).ClosePreview(Self);
//  if QRPrinter <> nil then QRPrinter := nil;
  FPrinterList.Free;
  inherited Destroy;
end;

function TQRPreview.GetPrinterCount: Integer;
begin
  Result := FPrinterList.Count;
end;

function TQRPreview.GetActivePrinterIndex: Integer;
begin
  Result := -1;
  if (FPrinterList.Count > 0) and (FPreviewImage.QRPRinter <> nil)
  then Result := FPrinterList.IndexOf(FPreviewImage.QRPRinter);
end;

procedure TQRPreview.SetActivePrinterIndex(Value: Integer);
begin
  if (FPrinterList.Count > 0) and ((Value >= 0) and (Value < FPrinterList.Count))
  then QRPrinter := TQRPrinter(FPrinterList.Items[Value])
  else QRPrinter := nil;
end;

function TQRPreview.GetQRPrinters(const Index: Integer): TQRPrinter;
begin
  Result := nil;
  if (Index >= 0) and (Index < FPrinterList.Count)
  then Result := TQRPrinter(FPrinterList.Items[Index]);
end;

function TQRPreview.GetTitle(const Index: Integer): String;
begin
  Result := '';
  if (Index >= 0) and (Index < FPrinterList.Count)
  then Result := TQRPrinter(FPrinterList.Items[Index]).Title;
  if Result = '' then Result := SqrNoName;
end;

function TQRPreview.Add(aQRPrinter: TQRPrinter): Integer;
begin
  Result := -1;
  if aQRPrinter <> nil then begin
    Result := FPrinterList.IndexOf(aQRPrinter);
    if Result < 0 then begin
      Result := FPrinterList.Add(aQRPrinter);
      if Assigned(aQRPrinter) then aQRPrinter.FreeNotification(Self);
//      if Assigned(aQRPrinter.Master) then aQRPrinter.Master.FreeNotification(Self);
      aQRPrinter.Client := self;
      aQRPrinter.ShowingPreview := true;
    end;
    if not Assigned(QRPrinter) then QRPrinter := aQRPrinter;
  end;
  if Assigned(FOnAddPrinter) then FOnAddPrinter(Self,aQRPrinter);
end;

function TQRPreview.Remove(aQRPrinter: TQRPrinter): Integer;
begin
  Result := -1;
  if Assigned(aQRPrinter) then begin
    Result := FPrinterList.Remove(AQRPrinter);
    if  not (csDestroying in ComponentState) and
     (PrintersCount > 0) then SetQRPrinter(QRPrinters[0])
    else SetQRPrinter(nil);
    if Assigned(FOnRemovePrinter) then FOnRemovePrinter(Self, aQRPrinter);
    aQRPrinter.Client := nil;
    aQRPrinter.ShowingPreview := false;

    aQRPrinter.ClosePreview(Self);
  end;
end;

function TQRPreview.IndexOfPrinter(Value: TQRPrinter): Integer;
begin
  Result := FPrinterList.IndexOf(Value);
end;

procedure TQRPreview.SwapPrinters(OldPrinter, NewPrinter: TQRPrinter);
var
  I: Integer;
begin
//  SetQRPrinter(nil);
//  Application.ProcessMessages;
  I := -1;
  if OldPrinter <> nil then begin
    I := IndexOfPrinter(OldPrinter);
    if assigned(OldPrinter) and (OldPrinter.Client = self)
    and (FPreviewImage.QRPrinter=OldPrinter) and (OldPrinter <> NewPrinter)
    then begin
      OldPrinter.Client := nil;
      OldPrinter.ShowingPreview := false;
    end;
  end;
//  if Assigned(OldPrinter) then Remove(OldPrinter)
//  else
//
//  SetQRPrinter(NewPrinter);
//  Application.ProcessMessages;

  if I >= 0
  then FPrinterList.Items[I] := NewPrinter
  else Add(NewPrinter);
  FPreviewImage.QRPrinter := NewPrinter;
  if NewPrinter <> nil then
  begin
    NewPrinter.Client := self;
    NewPrinter.ShowingPreview := true;
  end;

  FPageNumber := 1;
  FPreviewImage.PageNumber := FPageNumber;
  Invalidate;
  if Assigned(FOnSwapPrinter) then FOnSwapPrinter(Self, OldPrinter, NewPrinter);
  FPreviewImage.OnClick := OnClick;
  FPreviewImage.OnDblClick := OnDblClick;
  FPreviewImage.OnDragDrop := OnDragDrop;
  FPreviewImage.OnDragOver := OnDragOver;
  FPreviewImage.OnEndDrag := OnEndDrag;
  FPreviewImage.OnMouseDown := OnMouseDown;
  FPreviewImage.OnMouseMove := OnMouseMove;
  FPreviewImage.OnMouseUp := OnMouseUp;
end;

function TQRPreview.GetQRPrinter: TQRPrinter;
begin
//  Result := FPreviewImage.QRPrinter;
  Result := nil;
  if ActivePrinterIndex >= 0 then
    Result := QRPrinters[ActivePrinterIndex];
end;

procedure TQRPreview.SetQRPrinter(Value : TQRPrinter);
begin
//RSV
  if FPreviewImage.QRPrinter <> Value then begin
{RSV}
{
  if FQRPrinter <> Value then begin
    if assigned(FQRPrinter) and (FQRPrinter.Client = self) then
    begin
      FQRPrinter.Client := nil;
      FQRPrinter.ShowingPreview := false;
    end;
}
{!!!2209
    if assigned(FPreviewImage.QRPrinter) and (FPreviewImage.QRPrinter.Client = self) then
    begin
      FPreviewImage.QRPrinter.Client := nil;
      FPreviewImage.QRPrinter.ShowingPreview := false;
    end;
}
    if (Value<> nil) and (FPrinterList.IndexOf(Value) < 0)
    then Add(Value);
//    FQRPrinterIndex := FPrinterList.IndexOf(Value);
//    FQRPrinter := Value;

    FPreviewImage.QRPrinter := Value;
    if Value <> nil then
    begin
      Value.Client := self;
      Value.ShowingPreview := true;
    end;
    if Assigned(Value) then Value.FreeNotification(Self); 
  end;
//RSV

  PreviewImage.PageNumber := 1;
  PageNumber := 1;
  Invalidate;
  FPreviewImage.OnClick := OnClick;
  FPreviewImage.OnDblClick := OnDblClick;
  FPreviewImage.OnDragDrop := OnDragDrop;
  FPreviewImage.OnDragOver := OnDragOver;
  FPreviewImage.OnEndDrag := OnEndDrag;
  FPreviewImage.OnMouseDown := OnMouseDown;
  FPreviewImage.OnMouseMove := OnMouseMove;
  FPreviewImage.OnMouseUp := OnMouseUp;
end;

procedure TQRPreview.CMPageAvailable(var Message : TCM_QRPageAvailable);
begin
  if Message.PageCount = PageNumber then
  if not Assigned(Message.QRPrinter) or (Message.QRPrinter=QRPrinter)
  then UpdateImage;
  if assigned(FOnPageAvailableEvent) then
  try
    FOnPageAvailableEvent({Self}Message.QRPrinter, Message.PageCount);
  finally
  end;
end;

procedure TQRPreview.CMProgressUpdate(var Message : TCM_QRProgressUpdate);
begin
  if assigned(FOnProgressUpdateEvent) then
  try
    FOnProgressUpdateEvent({Self}Message.QRPrinter, Message.Position);
  finally
  end;
end;

procedure TQRPreview.CMQRSWAPPRINTER(var Message : TCM_QRSWAPPRINTER);
begin
  if Message.NewQRPrinter <> nil
  then try
    SwapPrinters(Message.OldQRPrinter, Message.NewQRPrinter);
  finally
  end;
end;

procedure TQRPreview.SetPageNumber(value : integer);
begin
  if ((Value <> FPageNumber) or (not PreviewImage.ImageOK)) and (Value > 0)
    and assigned(QRPrinter) and (Value <= QRPrinter.PageCount) then
  begin
    FPreviewImage.PageNumber := Value;
    FPageNumber := Value;
    VertScrollBar.Position := 0;
    HorzScrollBar.Position := 0;
  end;
end;

procedure TQRPreview.UpdateImage;
begin
  if assigned(FPreviewImage) and not FPreviewImage.ImageOK and
    (FPreviewImage.PageNumber <= QRPrinter.AvailablePages) then
  begin
//RSV    ZoomToWidth;
    Zoom := Zoom;
    FPreviewImage.PageNumber := FPreviewImage.PageNumber;
  end;
end;

procedure TQRPreview.UpdateZoom;
var
  dX, dY: Integer;
begin
  dX := HorzScrollBar.Position;
  dY := VertScrollBar.Position;
try
//  FPreviewImage.Canvas.Lock;
  FPreviewImage.Visible := False;
  HorzScrollBar.Position := 0;
  VertScrollBar.Position := 0;

  if assigned(QRPrinter) then
  begin
    with FPreviewImage do
    begin
{
      Width := round(QRPrinter.XSize(QRPrinter.PaperWidthValue / 100 * FZoom)) +
               cQRPageShadowWidth + cQRPageFrameWidth * 2;
      Height := round(QRPrinter.YSize(QRPrinter.PaperLengthValue / 100 * FZoom)) +
                cQRPageShadowWidth + cQRPageFrameWidth * 2;
}
      Width := QRPrinter.XSize(muldiv(QRPrinter.PaperWidthValue, FZoom,100)) +
               cQRPageShadowWidth + cQRPageFrameWidth * 2;
      Height := QRPrinter.YSize(muldiv(QRPrinter.PaperLengthValue, FZoom, 100)) +
                cQRPageShadowWidth + cQRPageFrameWidth * 2;
    end
  end else
  begin
    with FPreviewImage do
    begin
      Width := round(cQRPaperSizeMetrics[Letter, 0] / 100 * FZoom) +
               cQRPageShadowWidth + cQRPageFrameWidth * 2;
      Height := round(cQRPaperSizeMetrics[Letter, 1] / 100 * FZoom) +
                cQRPageShadowWidth + cQRPageFrameWidth * 2;
    end;
  end;
  if FPreviewImage.Width < self.Width then
    FPreviewImage.Left := (width - FPreviewImage.width) div 2
  else
    FPreviewImage.Left := 0;
  if FPreviewImage.Height < Height then
    FPreviewImage.Top := ((Height - FPreviewImage.Height) div 2)
  else
    FPreviewImage.Top := 0;
//RSV  HorzScrollBar.Position := 0;
//RSV  VertScrollBar.Position := 0;
  HorzScrollBar.Position := dX;
  VertScrollBar.Position := dY;
finally
//  FPreviewImage.Canvas.Unlock;
  FPreviewImage.Visible := True;
end;
  FPreviewImage.Zoom := FZoom;
end;

procedure TQRPreview.FixValues(Sender : TObject);
begin
  if ZoomState = qrZoomToFit then
    ZoomToFit
  else
    if ZoomState = qrZoomToWidth then
      ZoomToWidth;
  UpdateZoom;
end;

procedure TQRPreview.SetZoom(Value:integer);
begin
  if FZoom <> Value then
  begin
    if (Value < qrpMINZOOM) or (Value > qrpMAXZOOM) then begin
      if (Value < qrpMINZOOM) then Value := qrpMINZOOM;
      if (Value > qrpMAXZOOM) then Value := qrpMAXZOOM;
    end;
    ZoomState := qrZoomOther;
    FZoom := Value;
  end;
  UpdateZoom;
end;

procedure TQRPreview.ZoomToFit;
var
  Zoom1,
  Zoom2 : Integer;
begin
  if assigned(QRPrinter) then
  begin
    Zoom1 := round(Width / QRPrinter.XSize(QRPrinter.PaperWidthValue) * 95);
    Zoom2 := round(Height / QRPrinter.YSize(QRPrinter.PaperLengthValue) * 95);
  end else
  begin
    Zoom1 := round((Width / cQRPaperSizeMetrics[Letter, 0]) * 95);
    Zoom2 := round((Height / cQRPaperSizeMetrics[Letter, 1]) * 95);
  end;
  if Zoom1 < Zoom2 then
    Zoom := Zoom1
  else
    Zoom := Zoom2;
  ZoomState := qrZoomToFit;
end;

procedure TQRPreview.ZoomToWidth;
begin
  if assigned(QRPrinter) then
    Zoom := round((Width / QRPrinter.XSize(QRPrinter.PaperWidthValue)) * 90)
  else
    Zoom := round((Width / cQRPaperSizeMetrics[Letter, 0]) * 95);
  UpdateZoom;
  ZoomState := qrZoomToWidth;
end;

procedure TQRPreview.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if Operation = opRemove then begin
    if AComponent = QRPrinter then QRPrinter := nil;
    if FPrinterList.IndexOf(AComponent) >= 0 then Remove(TQRPrinter(AComponent)); 
  end;
end;

{ TQRExportFilter }

constructor TQRExportFilter.Create(Filename : string);
begin
  inherited Create;
  FFilename := Filename;
  FOwner := nil;
  Active := false;
end;

function TQRExportFilter.GetDescription : string;
begin
  result := SqrAbstractFilterDescription;
end;

function TQRExportFilter.GetExtension : string;
begin
  result := '';
end;

function TQRExportFilter.GetFilterName : string;
begin
  result := SqrAbstractFilterName;
end;

function TQRExportFilter.GetVendorName : string;
begin
  result := SqrQuSoft;
end;

function TQRExportFilter.GetStreaming : boolean;
begin
  Result := false;
end;

procedure TQRExportFilter.Start(PaperWidth, PaperHeight : integer; Font : TFont);
begin
  Active := true;
end;

procedure TQRExportFilter.EndPage;
begin
end;

procedure TQRExportFilter.Finish;
begin
  Active := false;
end;

procedure TQRExportFilter.NewPage;
begin
end;

procedure TQRExportFilter.TextOut(X,Y : extended; Font : TFont; BGColor : TColor; Alignment : TAlignment; Text : string);
begin
end;

{ TQRExportFilterLibrary }

constructor TQRExportFilterLibrary.Create;
begin
  inherited Create;
  FFilterList := TList.Create;
end;

destructor TQRExportFilterLibrary.destroy;
var
  I : integer;
begin
  for I := 0 to FFilterList.Count - 1 do
    TQRExportFilterLibraryEntry(FFilterList[I]).Free;
  FFilterList.Free;
  inherited Destroy;
end;

procedure TQRExportFilterLibrary.AddFilter(AFilter : TQRExportFilterClass);
var
  aTmpFilter : TQRExportFilter;
  aLibraryEntry : TQRExportFilterLibraryEntry;
begin
  aTmpFilter := AFilter.Create('');
  aLibraryEntry := TQRExportFilterLibraryEntry.Create;
  aLibraryEntry.ExportFilterClass := AFilter;
  aLibraryEntry.FilterName := aTmpFilter.Name;
  aLibraryEntry.Extension := aTmpFilter.FileExtension;
  aTmpFilter.Free;
  FFilterList.Add(aLibraryEntry);
end;

procedure TQRExportFilterLibrary.RemoveFilter(AFilter : TQRExportFilterClass);
var
  aTmpFilter : TQRExportFilter;
  I : integer;
  aLibraryEntry : TQRExportFilterLibraryEntry;
begin
  aTmpFilter := AFilter.Create('');
  for I := 0 to FFilterList.Count - 1 do
    if TQRExportFilterLibraryEntry(FFilterList[I]).FilterName = aTmpFilter.Name then
    begin
      aLibraryEntry := TQRExportFilterLibraryEntry(FFilterList[I]);
      FFilterList.Delete(I);
      aTmpFilter.Free;
      aLibraryEntry.Free;
      Exit;
    end;
end;

function TQRExportFilterLibrary.GetSaveDialogFilter : string;
var
  I : integer;
begin
  result := SqrQRFile + '(*.' +cQRPDefaultExt + ')|*.' + cqrpDefaultExt;
  for I := 0 to Filters.Count - 1 do
    with TQRExportFilterLibraryEntry(Filters[I]) do
        result := result + '|' + FilterName + ' (*.' + Extension + ')|*.' + Extension;
end;

{ TPrinterSettings }

constructor TPrinterSettings.Create;
begin
  inherited Create;
  GetMem(FDevice, 128);
  GetMem(FDriver, 128);
  GetMem(FPort, 128);
  FPaperSize := A4;
  FCopies    := 1;
  FDuplex    := False;
  FOrientation := poPortrait;
  FOutputBin := Auto;
  FPrinter := nil;
end;

destructor TPrinterSettings.Destroy;
begin
  FreeMem(FDevice, 128);
  FreeMem(FDriver, 128);
  FreeMem(FPort, 128);
  inherited Destroy;
end;

function TPrinterSettings.GetCopies : integer;
begin
  Result := FCopies;
end;

function TPrinterSettings.GetDriver : string;
begin
  Result := StrPas(FDriver);
//  Result := FDriver;
end;

function TPrinterSettings.GetDuplex : boolean;
begin
  Result := FDuplex;
end;

function TPrinterSettings.GetMaxExtentX : integer;
begin
  Result := FMaxExtentX;
end;

function TPrinterSettings.GetMaxExtentY : integer;
begin
  Result := FMaxExtentY;
end;

function TPrinterSettings.GetMinExtentX : integer;
begin
  Result := FMinExtentX;
end;

function TPrinterSettings.GetMinExtentY : integer;
begin
  Result := FMinExtentY;
end;

function TPrinterSettings.GetOrientation : TPrinterOrientation;
begin
  Result := FOrientation;
end;

function TPrinterSettings.GetOutputBin : TQRBin;
begin
  Result := FOutputBin;
end;

function TPrinterSettings.GetPaperSize : TQRPaperSize;
begin
  Result := FPaperSize;
end;

function TPrinterSettings.GetPaperSizeSupported(PaperSize : TQRPaperSize) : boolean;
begin
  result := FPaperSizes[PaperSize];
end;

function TPrinterSettings.GetPaperWidth : integer;
begin
  if (PaperSize <> Custom) and (PaperSize <> Default) then
    Result := round(cQRPaperSizeMetrics[PaperSize, 0] * 10)
  else
    Result := FPaperWidth;
end;

function TPrinterSettings.GetPaperLength : integer;
begin
  if (PaperSize <> Custom) and (PaperSize <> Default) then
    Result := round(cQRPaperSizeMetrics[PaperSize, 1] * 10)
  else
    Result := FPaperLength;
end;

function TPrinterSettings.GetPixelsPerX : integer;
begin
  Result := FPixelsPerX;
end;

function TPrinterSettings.GetPixelsPerY : integer;
begin
  Result := FPixelsPerY;
end;

function TPrinterSettings.GetPort : string;
begin
//RSV  Result := StrPas(FPort);
  Result := FPort;
end;

function TPrinterSettings.GetTopOffset : integer;
begin
  Result := FTopOffset;
end;

function TPrinterSettings.GetLeftOffset : integer;
begin
  Result := FLeftOffset;
end;

function TPrinterSettings.GetPrinter : TPrinter;
begin
  Result := FPrinter;
end;

function TPrinterSettings.GetTitle : string;
begin
  Result := FTitle;
end;

function TPrinterSettings.Supported(Setting : integer) : boolean;
begin
  Result := false;
  if assigned(FPrinter) then
    Result := (DevMode^.dmFields and Setting) = Setting
//RSV  else
//RSV    Supported := false;
end;

procedure TPrinterSettings.SetField(aField : integer);
begin
  DevMode^.dmFields := DevMode^.dmFields or aField;
end;

procedure TPrinterSettings.GetPrinterSettings;

  procedure GPrinter;
  var
    Driver_info_2 : pDriverinfo2;
    Retrieved : dword;
    hPrinter : THandle;

  begin
    Application.ProcessMessages;
//  3.0.8
    if not Assigned(FDevice) then GetMem(FDevice,128);
    FPrinter.GetPrinter(FDevice, FDriver, FPort, DeviceMode);
    if DeviceMode = 0 then
      FPrinter.GetPrinter(FDevice, FDriver, FPort, DeviceMode);
    GetMem(Driver_info_2, 255);
    try
      OpenPrinter(FDevice, hPrinter, nil);
      try
        GetPrinterDriver(hPrinter, nil, 2, Driver_info_2, 255, Retrieved);
      finally
        ClosePrinter(hPrinter);
      end;
      StrLCopy(FDriver, PChar(ExtractFileName(StrPas(Driver_info_2^.PDriverPath)) + #0), 63);
    finally
      FreeMem(Driver_info_2, 255);
    end;
    DevMode := GlobalLock(DeviceMode);
  end;

  procedure GCopies; { Number of copies }
  begin
    if Supported(dm_copies) then
      FCopies := DevMode^.dmCopies
    else
      FCopies := 1;
  end;

  procedure GBin; { Paper bin }
  var
    aBin : integer;
    I : TQRBin;
  begin
    FOutputBin := First;
    if Supported(dm_defaultsource) then
    begin
      aBin := DevMode^.dmDefaultSource;
      for I := First to Last do
      begin
        if cQRBinTranslate[I] = aBin then
        begin
          FOutputBin := I;
          exit;
        end
      end
    end
  end;

  procedure GDuplex; { Duplex }
  begin
    if Supported(dm_duplex) and (DevMode^.dmDuplex <> dmdup_simplex) then
      FDuplex := true
    else
      FDuplex := false;
  end;

  procedure GPixelsPer; { Horizontal and Vertical pixels per inch }
  begin
    FPixelsPerX := GetDeviceCaps(FPrinter.Handle, LOGPIXELSX);
    FPixelsPerY := GetDeviceCaps(FPrinter.Handle, LOGPIXELSY);
  end;

  procedure GOffset; { Top left printing offset (waste) }
  var
    PrintOffset: TPoint;
//    EscapeFunc: word;
  begin
    PrintOffset.X := GetDeviceCaps(FPrinter.Handle, PHYSICALOFFSETX);
    PrintOffset.Y := GetDeviceCaps(FPrinter.Handle, PHYSICALOFFSETY);
    FLeftOffset := round(PrintOffset.X/PixelsPerX*254);
    FTopOffset := round(PrintOffset.Y/PixelsPerY*254);
{
    EscapeFunc := GetPrintingOffset;
    if Escape(FPrinter.Handle,QueryEscSupport,SizeOf(EscapeFunc), @EscapeFunc,nil) <> 0 then
    begin
      Escape(FPrinter.Handle,GetPrintingOffset,0,nil,@PrintOffset);
    end else
    begin
      FLeftOffset := 0;
      FTopOffset := 0;
    end;}
  end;

  procedure GPaperSize;
  var
    aSize : integer;
    I : TQRPaperSize;
  begin
    FPaperSize := Default;
    if Supported(dm_papersize) then
    begin
      aSize := DevMode^.dmPaperSize;
      for I := Default to Custom do
      begin
        if aSize=cQRPaperTranslate[I] then
        begin
          FPaperSize := I;
          exit;
        end
      end
    end
  end;

  procedure GPaperDim;
  var
    PSize : TPoint;
//    EscapeFunc : word;
  begin
    PSize.X := GetDeviceCaps(FPrinter.Handle, PHYSICALWIDTH);
    PSize.Y := GetDeviceCaps(FPrinter.Handle, PHYSICALHEIGHT);
    FPaperWidth := round(PSize.X / PixelsPerX * 254);
    FPaperLength := round(PSize.Y / PixelsPerY * 254);
{    EscapeFunc := GetPhysPageSize;
    if Escape(FPrinter.Handle, QueryEscSupport, SizeOf(EscapeFunc), @EscapeFunc, nil) <> 0 then
    begin
      Escape(FPrinter.Handle, GetPhysPageSize, 0, nil, @PSize);
      FPaperWidth := round(PSize.X / PixelsPerX * 254);
      FPaperLength := round(PSize.Y / PixelsPerY * 254);
    end else
    begin
      FPaperWidth := 0;
      FPaperLength := 0;
    end}
  end;

  procedure GPaperSizes;
  var
    DCResult : array of word;
    I : integer;
    J : TQRPaperSize;
    Count : integer;
  begin
    Count := DeviceCapabilities(FDevice, FPort, DC_PAPERS, nil, DevMode);
    SetLength(DCResult, Count);
    Fillchar(Pointer(DCResult)^, Count * Sizeof(word), #0);
    Fillchar(FPaperSizes,Sizeof(FPaperSizes),#0);
    Count := DeviceCapabilities(FDevice, FPort, DC_PAPERS, PChar(DCResult), DevMode);
    for I := 0 to Count - 1 do
    begin
      for J := Default to Custom do
      begin
        if cQRPaperTranslate[J] = DCResult[I] then
        begin
          FPaperSizes[J] := true;
          break;
        end
      end
    end;
    FPaperSizes[Custom] := true;
  end;

begin
  if FPrinter<>nil then
  begin
    GPrinter;
    GPixelsPer;
    GCopies;
    GBin;
    GDuplex;
    GOffset;
    GPaperSize;
    GPaperDim;
    GPaperSizes;
    GlobalUnlock(DeviceMode);
  end
end;

procedure TPrinterSettings.ApplySettings;
begin
  FPrinter.GetPrinter(FDevice, FDriver, FPort, DeviceMode);
  DevMode := GlobalLock(DeviceMode);
  if PaperSize = Custom then
  begin
    if Supported(dm_paperlength) then
    begin
      SetField(dm_paperlength);
      DevMode^.dmPaperLength := PaperLength;
    end;
    if Supported(dm_PaperWidth) then
    begin
      SetField(dm_paperwidth);
      DevMode^.dmPaperWidth := PaperWidth;
    end
  end;

  If FDuplex then
  begin
    SetField(dm_duplex);
    DevMode^.dmDuplex := dmdup_horizontal;
  end;

  if Supported(dm_PaperSize) and
     (PaperSize <> Default) then
  begin
    SetField(dm_papersize);
    DevMode^.dmPaperSize := cQRPaperTranslate[PaperSize];
  end;

  SetField(dm_copies);
  DevMode^.dmCopies := FCopies;

  SetField(dm_defaultsource);
  DevMode^.dmDefaultSource := (DevMode^.dmDefaultSource  and 256) or cQRBinTranslate[OutputBin];

  SetField(dm_orientation);
  if Orientation=poPortrait then
    DevMode^.dmOrientation := dmorient_portrait
  else
    DevMode^.dmOrientation := dmorient_landscape;

  FPrinter.SetPrinter(FDevice, FDriver, FPort, DeviceMode);
  GlobalUnlock(DeviceMode);
end;

procedure TPrinterSettings.SetCopies(Value : integer);
begin
  if Supported(dm_copies) then
    FCopies := Value;
end;

procedure TPrinterSettings.SetDuplex(Value : boolean);
begin
  if Supported(dm_duplex) then
    FDuplex := Value;
end;

procedure TPrinterSettings.SetOrientation(Value : TPrinterOrientation);
begin
  if Supported(dm_orientation) then
    FOrientation := Value;
end;

procedure TPrinterSettings.SetOutputBin(Value : TQRBin);
begin
  if Supported(dm_defaultsource) then
    FOutputBin := Value;
end;

procedure TPrinterSettings.SetPaperSize(Value : TQRPaperSize);
begin
  if PaperSizeSupported[Value] then
    FPaperSize := Value
  else
    if (Value = Default) then
      FPaperSize := Default;
end;

procedure TPrinterSettings.SetPaperLength(Value : integer);
begin
  if PaperSize = Custom then
    FPaperLength := Value;
end;

procedure TPrinterSettings.SetPaperWidth(Value : integer);
begin
  if PaperSize = Custom then
    FPaperWidth := Value;
end;

procedure TPrinterSettings.SetPrinter(Value : TPrinter);
begin
  FPrinter := Value;
  if (Value <> nil) and (FPrinter.Printers.Count > 0) then
    GetPrinterSettings;
end;

procedure TPrinterSettings.SetTitle(Value : string);
begin
  FTitle := Value;
end;

{ TQRPrinterSettings }

constructor TQRPrinterSettings.Create;
begin
  PaperSize := Letter;
  Copies := 1;
  Duplex := false;
  Title := '';
  FFirstPage := 0;
  FLastPage := 0;
  FOrientation := poPortrait;
  FPrinterIndex := -1;
  FOutputBin := Auto;
end;

procedure TQRPrinterSettings.ApplySettings(APrinter : TQRPrinter);
begin
  aPrinter.PrinterIndex := PrinterIndex;
  aPrinter.PaperSize := PaperSize;
  aPrinter.Copies := Copies;
  aPrinter.Duplex := Duplex;
  aPrinter.Orientation := Orientation;
  aPrinter.OutputBin := OutputBin;
  aPrinter.Title := Title;
end;

{ TQRPrinter }

procedure ResetDriver(aPrinter : TPrinter);
var
  Device, Name, Port: array[0..255] of Char;
  DevMode: THandle;
begin
  aPrinter.GetPrinter( Device, Name, Port , DevMode );
  aPrinter.SetPrinter( Device, Name, Port , 0 );
end;

//RSV constructor TQRPrinter.Create;
constructor TQRPrinter.Create(AOwner: TComponent);
begin
{$ifdef EvalVersion}
  if not DelphiRunning then
  begin
    ShowMessage('This evaluation copy of QuickReport only works while Delphi is running. '+
                'Please contact QuSoft to order a full version');
    Application.Terminate;
  end;
{$endif}
  inherited Create(AOwner);

  FPrinterOK := Printer.Printers.Count > 0;
  aPrinter := TPrinter.Create;
  aPrinterSettings := TPrinterSettings.Create;
  if PrinterOK then
  begin
    aPrinterSettings.Printer := aPrinter;
    Application.ProcessMessages;
    if Printer.PrinterIndex > aPrinter.Printers.Count then
      aPrinter.PrinterIndex := Printer.PrinterIndex;
  end;
  FTopWaste := aPrinterSettings.TopOffset;
  FLeftWaste := aPrinterSettings.LeftOffset;
  FDestination := qrdMetafile;
  FStatus := mpReady;
  FPageNumber := 0;
  PageList := TQRPageList.Create;
{  FOnProgressChangeEvent := nil;}
  FAvailablePages := 0;
  FXFactor := 1;
  FYFactor := 1;
  FClient := nil;
  FMaster := nil;
  FAfterPreviewEvent := nil;
  FAfterPrintEvent := nil;
//  FOnPrintWithSetupEvent := nil;
  FCloseControl := nil;
  FShowingPreview := false;
  ReportLoaded := false;

  QRPrintersPool.AddPrinter(Self);
end;

procedure TQRPrinter.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
//    if AComponent = FMaster then FMaster := nil;
    if AComponent = FClient then FClient := nil;
    if AComponent = FCloseControl then FCloseControl := nil;
//    if AComponent = Owner then Free;
  end;
end;

destructor TQRPrinter.Destroy;
begin
  QRPrintersPool.RemovePrinter(Self);
  if Status <> mpReady then
    Cleanup;
//  if FCloseControl <> nil then
//    FCloseControl.Free;
  aPrinter.Free;
  aPrinterSettings.Free;
  PageList.Free;
  if FPage <> nil then
    FPage.Free;
  FCloseControl := nil;
  aPrinter := nil;
  PageList := nil;
  Client := nil;
{
  if Client <> nil then
    if Client is TQRPreview then
      TQRPreview(Client).QRPrinter:= nil;
}
  inherited Destroy;
end;

procedure TQRPrinter.Cleanup;
begin
  if Status = mpBusy then
    Cancel;
  if assigned(aStream) then
  begin
    aStream.Free;
    aStream := nil;
    PageList.Stream := nil;
  end;
  PageList.Clear;
  FStatus := mpReady;
end;

procedure TQRPrinter.ClosePreview(Control : TWinControl);
begin
  if (Master <> nil) and not (csDestroying in Master.ComponentState) then
//    SendMessage(Master.Handle, CM_QRPREVIEWCLOSE, 0, longint(Self));
    PostMessage(Master.Handle, CM_QRPREVIEWCLOSE, 0, longint(Self));

//  if PreviewControl <> nil then
//    PreviewControl.Free;
//  if (Control <> nil) and (Control is TCustomForm) then
//    TCustomForm(Control).Free;
//    PostMessage(Control.Handle, WM_DESTROY, 0, 0);
//  FCloseControl := Control;
end;

function TQRPrinter.XPos(Value : extended) : integer;
begin
  result := round((Value - FLeftWaste) * XFactor);
end;

function TQRPrinter.XSize(Value : extended) : integer;
begin
  result := round(Value * XFactor);
end;

function TQRPrinter.YPos(Value : extended) : integer;
begin
  result := round((Value - FTopWaste) * YFactor);
end;

function TQRPrinter.YSize(Value : extended) : integer;
begin
  result := round(Value * YFactor);
end;

function TQRPrinter.GetCompression : boolean;
begin
  Result := PageList.Compression;
end;

procedure TQRPrinter.SetCompression(Value : boolean);
begin
  PageList.Compression := Value;
end;

{ TQRPrinter methods related to printer driver settings }

function TQRPrinter.GetBin : TQRBin;
begin
  Result := aPrinterSettings.OutputBin;
end;

function TQRPrinter.GetCopies;
begin
  Result := aPrinterSettings.Copies;
end;

function TQRPrinter.GetDuplex : boolean;
begin
  Result := aPrinterSettings.Duplex;
end;

function TQRPrinter.GetLeftWaste : integer;
{ Return left unprintable area in 0.1 mm }
begin
  if Destination=qrdPrinter then
    Result := aPrinterSettings.LeftOffset
  else
    Result := 0;
end;

function TQRPrinter.GetOrientation : TPrinterOrientation;
begin
  Result := aPrinterSettings.Orientation;
end;

function TQRPrinter.GetPaperLength : integer;
{ Return physical paper length in 0.1 mm }
begin
  Result := aPrinterSettings.PaperLength;
end;

function TQRPrinter.PaperLengthValue : integer;
begin
  if Orientation = poPortrait then
  begin
    if (PaperSize <> Custom) and (PaperSize <> Default) then
      result := round(cqrPaperSizeMetrics[PaperSize, 1] * 10)
    else
      result := PaperLength;
  end else
  begin
    if (PaperSize <> Custom) and (PaperSize <> Default) then
      result := round(cqrPaperSizeMetrics[PaperSize, 0] * 10)
    else
      result := PaperWidth;
  end;
end;

function TQRPrinter.PaperWidthValue : integer;
begin
  if Orientation = poPortrait then
  begin
    if (PaperSize <> Custom) and (PaperSize <> Default) then
      result := round(cqrPaperSizeMetrics[PaperSize, 0] * 10)
    else
      result := PaperWidth;
  end else
  begin
    if (PaperSize <> Custom) and (PaperSize <> Default) then
      result := round(cqrPaperSizeMetrics[PaperSize, 1] * 10)
    else
      result := PaperLength;
  end;
end;

function TQRPrinter.GetPaperWidth : integer;
{ Return physical paper width in 0.1 mm }
begin
  Result := aPrinterSettings.PaperWidth;
end;

function TQRPrinter.GetPaperSize : TQRPaperSize;
{ Return currently selected paper size }
begin
  Result := aPrinterSettings.PaperSize;
end;

function TQRPrinter.GetPrinterIndex : integer;
{ Return currently selected printer }
begin
  result := aPrinter.PrinterIndex;
end;

function TQRPrinter.GetPrinters : TStrings;
{ Return list of printers }
begin
  result := aPrinter.Printers;
end;

function TQRPrinter.GetTopWaste : integer;
{ Return unprintable area on top in 0.1 mm }
begin
  if Destination=qrdPrinter then
    Result := aPrinterSettings.TopOffset
  else
    Result := 0;
end;

procedure TQRPrinter.SetBin(Value : TQRBin);
begin
  aPrinterSettings.Outputbin := Value;
end;

procedure TQRPrinter.SetCopies(Value : integer);
begin
  aPrinterSettings.Copies := Value;
end;

procedure TQRPrinter.SetDestination(Value : TQRPrinterDestination);
begin
  FDestination := Value;
end;

procedure TQRPrinter.SetDuplex(Value : Boolean);
begin
  aPrinterSettings.Duplex := Value;
end;

procedure TQRPrinter.SetOrientation(Value : TPrinterOrientation);
begin
  aPrinterSettings.Orientation := Value;
end;

procedure TQRPrinter.SetPaperWidth(Value : integer);
{ Sets the paper width in 0.01 mm }
begin
  aPrinterSettings.PaperWidth := Value;
end;

function TQRPrinter.GetPage(Value : integer) : TMetafile;
begin
  if (Status in [mpBusy, mpFinished]) and
     (Value > 0) and (Value <= FPageCount) then
    Result := PageList.GetPage(Value)
  else
    Result := nil;
end;

procedure TQRPrinter.SetPageNumber(Value : integer);
begin
  if (PageNumber > 0) and (PageNumber <= FPageCount) then
  begin
    if FPage <> nil then
      FPage.Free;
    FPage := GetPage(Value);
    FPageNumber := Value;
  end;
end;

procedure TQRPrinter.SetPaperLength(Value : integer);
{ Sets the paper length in 0.1 mm }
begin
  aPrinterSettings.PaperLength := Value;
end;

procedure TQRPrinter.SetPaperSize(Value : TQRPaperSize);
begin
  aPrinterSettings.PaperSize := Value;
end;

procedure TQRPrinter.SetPrinterIndex(Value : integer);
begin
  if PrinterOK then
  begin
    aPrinter.PrinterIndex := Value;
    ResetDriver(aPrinter);
    aPrinterSettings.GetPrinterSettings;
  end;
end;

{ TQRPrinter methods related to printing }

function TQRPrinter.GetCanvas;
begin
  result := FCanvas;
end;

procedure TQRPrinter.CreateMetafileCanvas;
begin
  FMetafile := TMetafile.Create;
  FMetafile.Width := XSize(PaperWidthValue);
  FMetafile.Height := YSize(PaperLengthValue);
  FCanvas := TMetafileCanvas.Create(FMetafile, 0);
  YFactor := Screen.PixelsPerInch / 254;
  XFactor := YFactor;
end;

function TQRPrinter.CurrentPageOK : boolean;
begin
  Result := true;
  if (FirstPage > 0) and (PageCount < FirstPage) then
    Result := false;
  if (LastPage > 0) and (PageCount > LastPage) then
    Result := false;
end;

procedure TQRPrinter.CreatePrinterCanvas;
begin
  if not aPrinter.Printing then
  begin
    aPrinter.Title := Title;
    aPrinter.BeginDoc;
    FCanvas := aPrinter.Canvas;
  end else
  begin
    StartPage(aPrinter.Handle);
    FCanvas := aPrinter.Canvas;
    Canvas.Refresh;
  end;
//>RSV
  SelectClipRgn(APrinter.Handle, 0);
//<RSV
  XFactor := GetDeviceCaps(aPrinter.Handle, LogPixelsX) / 254;
  YFactor := GetDeviceCaps(aPrinter.Handle, LogPixelsY) / 254;
end;

procedure TQRPrinter.EndMetafileCanvas;
begin
  Canvas.Free;
end;

procedure TQRPrinter.EndPrinterCanvas;
begin
//RSV!!!!        
//  
  if aPrinter.Printing and (PageCount <> LastPage) then
    aPrinter.NewPage;
end;

procedure TQRPrinter.NewPage;
begin
  if Status <> mpBusy then
    raise EQRError.Create(SqrIllegalNewPage);
  if PageNumber > 0 then
  begin
    case Destination of
      qrdMetafile: begin
                    EndMetafileCanvas;
                    PageList.AddPage(FMetafile);
                    FMetafile.Free;
                  end;
      qrdPrinter: begin
                    if CurrentPageOK then
                      EndPrinterCanvas
                    else
                    begin
                      EndMetafileCanvas;
                      FMetaFile.Free;
                    end;
                  end;
    end;
    AvailablePages := AvailablePages + 1;
  end;
  inc(FPageCount);
  inc(FPageNumber);
  case Destination of
    qrdMetafile : CreateMetafileCanvas;
    qrdPrinter : if CurrentPageOK then
                   CreatePrinterCanvas
                 else
                   CreateMetafileCanvas;
  end;
end;

procedure TQRPrinter.Cancel;
begin
  Cancelled := true;
end;

procedure TQRPrinter.BeginDoc;
var
  OldStream: TQRStream;
begin
  if FMetafile <> nil then FMetafile.Free;
  FMetafile := nil;
  FAvailablePages := 0;
  FCancelled := false;
  if Destination = qrdPrinter then
    aPrinterSettings.ApplySettings;
  FTopWaste := TopWaste;
  FLeftWaste := LeftWaste;
  if Status <> mpReady then
    raise EQRError.Create(SqrQRPrinterNotReady)
  else
  begin
    FPageNumber := 0;
    FPageCount := 0;
    FStatus := mpBusy;
    case Destination of
      qrdMetafile : begin
//RSV                      aStream := TQRStream.Create(100000);
                      aStream := TQRStream.Create(0);
                      OldStream := PageList.Stream;
                      if OldStream <> nil then OldStream.Free;
                      PageList.Stream := aStream;
                      YFactor := Screen.PixelsPerInch / 254;
                      XFactor := YFactor;
                    end;
      qrdPrinter : begin
                     XFactor := GetDeviceCaps(aPrinter.Handle, LogPixelsX) / 254;
                     YFactor := GetDeviceCaps(aPrinter.Handle, LogPixelsY) / 254;
                   end;
    end;
  end;
end;

procedure TQRPrinter.SetAvailablePages(Value : integer);
begin
  FAvailablePages := Value;
  if Client <> nil then
    PostMessage(Client.Handle, CM_QRPAGEAVAILABLE, Value, Integer(Self));
//    SendMessage(Client.Handle, CM_QRPAGEAVAILABLE, Value, 0);
end;

procedure TQRPrinter.SetProgress(Value : integer);
begin
  FProgress := Value;
  if Client <> nil then
    PostMessage(Client.Handle, CM_QRPROGRESSUPDATE, Value, Integer(Self))
//    SendMessage(Client.Handle, CM_QRPROGRESSUPDATE, Value, 0)
end;

procedure TQRPrinter.DoAfterPreview;
begin
  if assigned(FAfterPreviewEvent) then
    FAfterPreviewEvent(Self);
end;

procedure TQRPrinter.SetShowingPreview(Value : boolean);
begin
  if ShowingPreview and not Value then
  try
    if Status = mpBusy then Cancel;
    DoAfterPreview;
  finally
    FShowingPreview := Value;
  end else
    FShowingPreview := Value;
//  if not Value then PreviewControl := nil;  
//
end;

procedure TQRPrinter.EndDoc;
begin
  if FStatus = mpBusy then
  begin
    case Destination of
      qrdPrinter : if aPrinter.Printing then aPrinter.EndDoc;
      qrdMetafile : begin
                      if FPageCount > 0 then
                      begin
                        EndMetafileCanvas;
                        PageList.AddPage(FMetafile);
                        FMetafile.Free;
                      end;
                    end;
    end;
    FStatus := mpFinished;
    Application.ProcessMessages;
    AvailablePages := AvailablePages + 1;
    if Destination = qrdMetafile then
      PageList.Finish
    else
      DoAfterPrint;
  end;
end;

procedure TQRPrinter.DoAfterPrint;
begin
  if assigned(FAfterPrintEvent) then
  try
    FAfterPrintEvent(Self);
  finally
  end;
end;

procedure TQRPrinter.AbortDoc;
begin
  case Destination of
    qrdPrinter : aPrinter.Abort;
    qrdMetafile : begin
                    if FMetafile <> nil then
                    begin
                      EndMetafileCanvas;
                      PageList.AddPage(FMetafile);
                      FMetafile.Free;
                    end;
                  end;
  end;
  FStatus := mpFinished;
end;

procedure TQRPrinter.Load(Filename : string);
var
  I : TQRPaperSize;
  H, V : integer;
begin
  if Status <> mpReady then
    CleanUp;
  PageList.LoadFromFile(Filename);
  FPageCount := PageList.PageCount;
  FXFactor := Screen.PixelsPerInch / 254;
  FYFactor :=FXFactor;
  if FPageCount > 0 then
  begin
    with PageList.GetPage(1) do
    try
      h := round(int(Width / XFactor / 40));
      v := round(int(Height / XFactor / 40));
    finally
      free;
    end;
    for I := Letter to ESheet do
    begin
      if (round(int(cQRPaperSizeMetrics[I][0] / 4)) = h) and
         (round(int(cQRPaperSizeMetrics[I][1] / 4)) = v) then
      begin
        PaperSize := I;
        Orientation := poPortrait;
      end;
      if (round(int(cQRPaperSizeMetrics[I][0] / 4)) = v) and
         (round(int(cQRPaperSizeMetrics[I][1] / 4)) = h) then
      begin
        PaperSize := I;
        Orientation := poLandscape;
      end;
    end;
  end;
  aStream := PageList.Stream;
  FStatus := mpFinished;
//  FOnGenerateToPrinterEvent := nil;
  FOnPrintSetupEvent := nil;
  FOnExportToFilterEvent := nil;
  ReportLoaded := true;
end;

procedure TQRPrinter.Save(Filename : string);
begin
  if Status = mpFinished then
    PageList.SaveToFile(Filename);
end;

procedure TQRPrinter.ExportToFilter(AFilter : TQRExportFilter);
begin
  if assigned(FOnExportToFilterEvent) then
    FOnExportToFilterEvent(AFilter);
end;

procedure TQRPrinter.SetPreviewControl(Value: TWinControl);
begin
  if Value <> FPreviewControl then begin
    FPreviewControl := Value;
    if Value = nil then ClosePreview(Value);
  end;
end;

procedure TQRPrinter.Preview;
begin
  if assigned(FOnPreviewEvent) then
  try
    FOnPreviewEvent(Self)
  finally
  end else
    with GlobalPreviewInterface.Create(nil) do
    try
      PreviewControl := Show(Self)
    finally
      Free;
    end;
end;

procedure TQRPrinter.RePreview;
begin
  if Assigned(Master) then
    PostMessage(Master.Handle, CM_QRREPREVIEW, 0, longint(Self))
{
  if Owner <> nil then
    PostMessage(TCustomPanel(Owner).Handle, CM_QRREPREVIEW, 0, longint(Self));
    SendMessage(TCustomPanel(Owner).Handle, CM_QRREPREVIEW, 0, longint(Self));
}
end;

procedure TQRPrinter.Swap(NewPrinter: TQRPrinter);
begin
  if Client <> nil then begin
    AfterPreview := nil;
    AfterPrint := nil;
    PostMessage(Client.Handle, CM_QRSWAPPRINTER,
      LongInt(Self), LongInt(NewPrinter));
  end;
end;

function TQRPrinter.GetMaster: TWinControl;
begin
  Result := FMaster;
end;

procedure TQRPrinter.SetMaster(Value: TWinControl);
begin
  FMaster := Value;
end;

procedure TQRPrinter.AddToPreview;
begin
  if assigned(FOnPreviewEvent) then
  try
    FOnPreviewEvent(Self)
  finally
  end else
    with GlobalPreviewInterface.Create(nil) do
    try
      PreviewControl := Add(Self);
    finally
      Free;
    end;
end;

procedure TQRPrinter.PreviewModal;
begin
  if assigned(FOnPreviewEvent) then
  try
    FOnPreviewEvent(Self)
  finally
  end else
    with GlobalPreviewInterface.Create(nil) do
    try
      ShowModal(Self)
    finally
      Free;
    end;
end;

procedure TQRPrinter.Print;
type
  TSmallPoint = record
    X,
    Y : integer;
  end;
var
  I : integer;
//  Count : integer;
  aPoint : TSmallPoint;
  ASize : TPoint;
//  EscapeFunc : word;
  APage : TMetafile;
  FromPage, ToPage: integer;
begin
{$ifdef EVAL}
  if not DelphiRunning then
    MessageDlg('Unregistered evaluation copy - Printing is only allowed while Delphi is running',mtWarning,[mbOK],0)
  else
{$endif}
    if assigned(FMaster) and not ReportLoaded then
      PostMessage(Master.Handle, CM_QRPRINT, 0, 0)
//      SendMessage(Master.Handle, CM_QRPRINT, 0, 0)
    else
      if (Status = mpFinished) and PrinterOK then
      try
        APrinter.Title := Title;
        if APrinter.Printing then
          APrinter.Abort;
        APrinterSettings.ApplySettings;
        APrinter.BeginDoc;
//        Count := 0;

        FromPage := 1;
        ToPage := PageCount;
{
        if (FirstPage <> 0) or (LastPage <> 0) then
        begin
          FromPage := FirstPage;
          ToPage := LastPage;
        end;
}
        if FirstPage <> 0 then
          FromPage := FirstPage;

        if LastPage <> 0 then
          ToPage := LastPage;

        for I := FromPage to ToPage do
        begin
          Application.ProcessMessages;
          PageNumber := I;

          aPoint.X := GetDeviceCaps(APrinter.Handle, PHYSICALOFFSETX);
          aPoint.Y := GetDeviceCaps(APrinter.Handle, PHYSICALOFFSETY);
          aSize.X := GetDeviceCaps(APrinter.Handle, PHYSICALWIDTH);
          aSize.Y := GetDeviceCaps(APrinter.Handle, PHYSICALHEIGHT);

{          EscapeFunc := GetPhysPageSize;
          if Escape(APrinter.Handle, QueryEscSupport, SizeOf(EscapeFunc), @EscapeFunc, nil) <> 0 then
            Escape(APrinter.Handle, GetPhysPageSize, 0, nil, @ASize);
          EscapeFunc := GetPrintingOffset;
          if Escape(APrinter.Handle, QueryEscSupport, SizeOf(EscapeFunc), @EscapeFunc, nil) <> 0 then
            Escape(APrinter.Handle, GetPrintingOffset, Count, @aPoint, @aPoint);}
          APage := GetPage(I);
          try
//>RSV
//            SelectClipRgn(APrinter.Handle, 0);
//<RSV
            APrinter.Canvas.StretchDraw(Rect(0, 0, APrinter.PageWidth+1, APrinter.PageHeight+1), APage);
          finally
            APage.Free;
          end;
//          if I < PageCount then APrinter.NewPage;
          if I < ToPage then APrinter.NewPage;
          if Cancelled then
            APrinter.Abort;
        end
      finally
        if APrinter.Printing then
          APrinter.EndDoc;
      end;
end;

procedure TQRPrinter.PrintWithSetup;
var
  ERes: Boolean;
begin
  if assigned(FMaster) and not ReportLoaded then
     SendMessage(Master.Handle, CM_QRPRINTWITHSETUP, 0, longint(Self))
  else if assigned(FOnPrintWithSetupEvent)
    then begin
      ERes := False;
      FOnPrintWithSetupEvent(ERes);
      if ERes then Print;
    end;
end;

procedure TQRPrinter.PrintSetup;
begin
  if assigned(FOnPrintSetupEvent) then
    FOnPrintSetupEvent;
end;

function QRPrinter : TQRPRinter;
begin
  if FQRPrinter = nil then
//    FQRPrinter := TQRPrinter.Create;
    FQRPrinter := TQRPrinter.Create(Application);
  Result := FQRPrinter;
end;

procedure RegisterPreviewClass(APreviewInterface : TQRPreviewInterfaceClass);
begin
  GlobalPreviewInterface := APreviewInterface;
end;

initialization
  FQRPrinter := nil;
  GlobalQRPreview := nil;
  QRPrintersPool := TQRPrinterPool.Create;
  GlobalPreviewInterface := TQRStandardPreviewInterface;
  QRExportFilterLibrary := TQRExportFilterLibrary.Create;

finalization
// if FQRPrinter <> nil then
//    FQRPrinter.Free;
  QRExportFilterLibrary.Free;
  ClearGlobalPreview(GlobalQRPreview);
  QRPrintersPool.Free;
  QRPrintersPool := nil;
end.
