{===================================================================================================

  Comming Library.

    TcoCheckBox.

====================================================================================================

  :

  28.10.2004 [*] .
  30.01.2003 [*]    CommingDesign  CommingRuntime
  02.07.2001 [*]   Delphi6.
  09.06.2001 [+]   FlatStyle.
  09.09.1998 [!]  Comming Library.

====================================================================================================
  Copyright 19982004 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingCheckBox.pas,v 1.7 2008/06/19 04:24:22 tsk Exp $
===================================================================================================}
unit CommingCheckBox;

interface

// {$I Version.inc}

uses  Windows, Messages, Classes, Graphics, Controls, Forms, ExtCtrls(*, FlatUtilitys*), CommingColor;
//      DesignIntf, CommingBinding;

type

  TCheckBoxLayout = ( checkboxLeft, checkboxRight );

  TcoCheckBox = class( TCustomControl )
  private
//    FUseAdvColors: Boolean;
//    FAdvColorFocused: TAdvColors;
//    FAdvColorDown: TAdvColors;
//    FAdvColorBorder: TAdvColors;
//    FMouseInControl: Boolean;
    MouseIsDown: Boolean;
    Focused: Boolean;
    FLayout: TCheckBoxLayout;
    FChecked: Boolean;
//    FFocusedColor: TColor;
//    FDownColor: TColor;
//    FCheckColor: TColor;
//    FBorderColor: TColor;
//    procedure SetColors (Index: Integer; Value: TColor);
//    procedure SetAdvColors (Index: Integer; Value: TAdvColors);
//    procedure SetUseAdvColors (Value: Boolean);
    procedure SetLayout (Value: TCheckBoxLayout);
    procedure SetChecked (Value: Boolean);
    procedure CMEnabledChanged (var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure CMTextChanged (var Message: TWmNoParams); message CM_TEXTCHANGED;
    procedure CMDialogChar (var Message: TCMDialogChar); message CM_DIALOGCHAR;
    procedure CNCommand (var Message: TWMCommand); message CN_COMMAND;
    procedure WMSetFocus (var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus (var Message: TWMKillFocus); message WM_KILLFOCUS;
//    procedure CMSysColorChange (var Message: TMessage); message CM_SYSCOLORCHANGE;
//    procedure CMParentColorChanged (var Message: TWMNoParams); message CM_PARENTCOLORCHANGED;
//    procedure RemoveMouseTimer;
//    procedure MouseTimerHandler (Sender: TObject);
    procedure CMDesignHitTest (var Message: TCMDesignHitTest); message CM_DESIGNHITTEST;
  protected
//    procedure CalcAdvColors;
    procedure DoEnter; override;
    procedure DoExit; override;
    procedure MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
//    procedure MouseMove (Shift: TShiftState; X, Y: Integer); override;
    procedure CreateWnd; override;
    procedure DrawCheckRect;
    procedure DrawCheckText;
    procedure Paint; override;
  public
    constructor Create (AOwner: TComponent); override;
//    destructor Destroy; override;
//    procedure MouseEnter;
//    procedure MouseLeave;
  published
    property Caption;
    property Checked: Boolean read FChecked write SetChecked default false;
    property Color (*default $00E1EAEB*);
//    property ColorFocused: TColor index 0 read FFocusedColor write SetColors default clWhite;
//    property ColorDown: TColor index 1 read FDownColor write SetColors default $00C5D6D9;
//    property ColorCheck: TColor index 2 read FCheckColor write SetColors default clBlack;
//    property ColorBorder: TColor index 3 read FBorderColor write SetColors default $008396A0;
//    property AdvColorFocused: TAdvColors index 0 read FAdvColorFocused write SetAdvColors default 10;
//    property AdvColorDown: TAdvColors index 1 read FAdvColorDown write SetAdvColors default 10;
//    property AdvColorBorder: TAdvColors index 2 read FAdvColorBorder write SetAdvColors default 50;
//    property UseAdvColors: Boolean read FUseAdvColors write SetUseAdvColors default false;
    property Enabled;
    property Font;
    property Layout: TCheckBoxLayout read FLayout write SetLayout default checkBoxLeft;
    property ParentColor;
    property ParentFont;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
//   {$IFDEF D4CB4}
    property Anchors;
    property BiDiMode;
    property Constraints;
    property DragKind;
    property ParentBiDiMode;
//    property OnEndDock;
//    property OnStartDock;
//   {$ENDIF}
  end;

//var
//  MouseInControl: TcoCheckBox = nil;

//  procedure Register;

implementation

//var
//  MouseTimer: TTimer = nil;
//  ControlCounter: Integer = 0;

procedure TcoCheckBox.CMDesignHitTest(var Message: TCMDesignHitTest);
begin
  case FLayout of
    checkboxLeft:
      if PtInRect(Rect(ClientRect.Left + 1, ClientRect.Top + 3, ClientRect.Left + 12, ClientRect.Top + 14), Point(message.XPos, message.YPos)) then
        Message.Result := 1
      else
        Message.Result := 0;
    checkboxRight:
      if PtInRect(Rect(ClientRect.Right - 12, ClientRect.Top + 3, ClientRect.Right - 1, ClientRect.Top + 14), Point(message.XPos, message.YPos)) then
        Message.Result := 1
      else
        Message.Result := 0;
  end;
end;

constructor TcoCheckBox.Create (AOwner: TComponent);
begin
  inherited Create(AOwner);
(*  if MouseTimer = nil then
  begin
    MouseTimer := TTimer.Create(nil);
    MouseTimer.Enabled := False;
    MouseTimer.Interval := 100; // 10 times a second
  end;*)
  ParentColor := True;
  ParentFont := True;
//  FFocusedColor := clWhite;
//  FDownColor := $00C5D6D9;
//  FCheckColor := clBlack;
//  FBorderColor := $008396A0;
  FLayout := checkboxLeft;
  TabStop := True;
  FChecked := false;
  Enabled := true;
  Visible := true;
//  SetBounds(0, 0, 121, 20);
  SetBounds(0, 0, 121, 17);
//  FUseAdvColors := false;
//  FAdvColorFocused := 10;
//  FAdvColorDown := 10;
//  FAdvColorBorder := 50;
//  Inc(ControlCounter);
end;

(*destructor TcoCheckBox.Destroy;
begin
//  RemoveMouseTimer;
  Dec(ControlCounter);
  if ControlCounter = 0 then
  begin
    MouseTimer.Free;
    MouseTimer := nil;
  end;
  inherited;
end;*)

(*procedure TcoCheckBox.SetColors (Index: Integer; Value: TColor);
begin
  case Index of
    0: FFocusedColor := Value;
    1: FDownColor := Value;
    2: FCheckColor := Value;
    3: FBorderColor := Value;
  end;
  Invalidate;
end;*)

(*procedure TcoCheckBox.CalcAdvColors;
begin
  if FUseAdvColors then
  begin
    FFocusedColor := CalcAdvancedColor(Color, FFocusedColor, FAdvColorFocused, lighten);
    FDownColor := CalcAdvancedColor(Color, FDownColor, FAdvColorDown, darken);
    FBorderColor := CalcAdvancedColor(Color, FBorderColor, FAdvColorBorder, darken);
  end;
end;

procedure TcoCheckBox.SetAdvColors (Index: Integer; Value: TAdvColors);
begin
  case Index of
    0: FAdvColorFocused := Value;
    1: FAdvColorDown := Value;
    2: FAdvColorBorder := Value;
  end;
  CalcAdvColors;
  Invalidate;
end;

procedure TcoCheckBox.SetUseAdvColors (Value: Boolean);
begin
  if Value <> FUseAdvColors then
  begin
    FUseAdvColors := Value;
    ParentColor := Value;
    CalcAdvColors;
    Invalidate;
  end;
end;*)

procedure TcoCheckBox.SetLayout (Value: TCheckBoxLayout);
begin
  FLayout := Value;
  Invalidate;
end;

procedure TcoCheckBox.SetChecked (Value: Boolean);
begin
  if FChecked <> Value then
  begin
    FChecked := Value;
    Click;
    DrawCheckRect;
    if csDesigning in ComponentState then
      if (GetParentForm(self) <> nil) and (GetParentForm(self).Designer <> nil) then
        GetParentForm(self).Designer.Modified;
  end;
end;

procedure TcoCheckBox.CMEnabledChanged (var Message: TMessage);
begin
  inherited;
(*  if not Enabled then
  begin
    FMouseInControl := False;
    MouseIsDown := False;
    RemoveMouseTimer;
  end;*)
  Invalidate;
end;

procedure TcoCheckBox.CMTextChanged (var Message: TWmNoParams);
begin
  inherited;
  Invalidate;
end;

(*procedure TcoCheckBox.MouseEnter;
begin
  if Enabled and not FMouseInControl then
  begin
    FMouseInControl := True;
    DrawCheckRect;
  end;
end;

procedure TcoCheckBox.MouseLeave;
begin
  if Enabled and FMouseInControl and not MouseIsDown then
  begin
    FMouseInControl := False;
    RemoveMouseTimer;
    DrawCheckRect;
  end;
end;*)

procedure TcoCheckBox.CMDialogChar (var Message: TCMDialogChar);
begin
  with Message do
    if IsAccel(Message.CharCode, Caption) and CanFocus then
    begin
      SetFocus;
      if Checked then
        Checked := False
      else
        Checked := True;
      Result := 1;
    end
    else
      if (CharCode = VK_SPACE) and Focused then
      begin
        if Checked then
          Checked := False
        else
          Checked := True;
      end
      else
        inherited;
end;

procedure TcoCheckBox.CNCommand (var Message: TWMCommand);
begin
  if Message.NotifyCode = BN_CLICKED then Click;
end;

procedure TcoCheckBox.WMSetFocus (var Message: TWMSetFocus);
begin
  inherited;
  if Enabled then
  begin
    Focused := True;
    DrawCheckRect;
  end;
end;

procedure TcoCheckBox.WMKillFocus (var Message: TWMKillFocus);
begin
  inherited;
  if Enabled then
  begin
//    FMouseInControl := False;
    Focused := False;
    DrawCheckRect;
  end;
end;

(*procedure TcoCheckBox.CMSysColorChange (var Message: TMessage);
begin
  if FUseAdvColors then
  begin
    ParentColor := True;
    CalcAdvColors;
  end;
  Invalidate;
end;

procedure TcoCheckBox.CMParentColorChanged (var Message: TWMNoParams);
begin
  inherited;
  if FUseAdvColors then
  begin
    ParentColor := True;
    CalcAdvColors;
  end;
  Invalidate;
end;*)

procedure TcoCheckBox.DoEnter;
begin
  inherited DoEnter;
  Focused := True;
  DrawCheckRect;
end;

procedure TcoCheckBox.DoExit;
begin
  inherited DoExit;
  Focused := False;
  DrawCheckRect;
end;

procedure TcoCheckBox.MouseDown (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and Enabled then
  begin
    SetFocus;
    MouseIsDown := true;
    DrawCheckRect;
    inherited MouseDown(Button, Shift, X, Y);
  end;
end;

procedure TcoCheckBox.MouseUp (Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and Enabled then
  begin
    MouseIsDown := false;
//    if FMouseInControl then
      if Checked then
        Checked := False
      else
        Checked := True;
    DrawCheckRect;
    inherited MouseUp(Button, Shift, X, Y);
  end;
end;

(*procedure TcoCheckBox.MouseMove (Shift: TShiftState; X, Y: Integer);
var
  P: TPoint;
begin
  inherited;
  // mouse is in control ?
  P := ClientToScreen(Point(X, Y));
  if (MouseInControl <> Self) and (FindDragTarget(P, True) = Self) then
  begin
    if Assigned(MouseInControl) then
      MouseInControl.MouseLeave;
    // the application is active ?
    if (GetActiveWindow <> 0) then
    begin
      if MouseTimer.Enabled then
        MouseTimer.Enabled := False;
      MouseInControl := Self;
      MouseTimer.OnTimer := MouseTimerHandler;
      MouseTimer.Enabled := True;
      MouseEnter;
    end;
  end;
end;            *)

procedure TcoCheckBox.CreateWnd;
begin
  inherited CreateWnd;
  SendMessage(Handle, BM_SETCHECK, Cardinal(FChecked), 0);
end;

procedure TcoCheckBox.DrawCheckRect;
var
  CheckboxRect: TRect;
begin
  case FLayout of
    checkboxLeft:
//      CheckboxRect := Rect(ClientRect.Left + 1, ClientRect.Top + 3, ClientRect.Left + 18, ClientRect.Top + 20);
      CheckboxRect := Rect(ClientRect.Left + 1, ClientRect.Top + 3, ClientRect.Left + 14, ClientRect.Top + 16);
    checkboxRight:
      CheckboxRect := Rect(ClientRect.Right - 14, ClientRect.Top + 3, ClientRect.Right - 1, ClientRect.Top + 16);
  end;

  canvas.pen.style := psSolid;
  canvas.pen.width := 1;
  // Background
(*  if Focused or FMouseInControl then be
    if not MouseIsDown then
    begin*)
  if Enabled then begin
      canvas.brush.color := clDimWindow; // FFocusedColor;
      canvas.pen.color   := clDimWindow; // FFocusedColor;
  end else begin
      canvas.brush.color := clBtnFace; // FFocusedColor;
      canvas.pen.color   := clBtnFace; // FFocusedColor;
  end;
(*    end
    else
    begin
      canvas.brush.color := FDownColor;
      canvas.brush.color := FDownColor;
    end
  else
  begin
    canvas.brush.color := Color;
    canvas.pen.color := Color;
  end;   *)
  canvas.FillRect( CheckboxRect );
  // Tick
  if Checked then
  begin
    if Enabled then
      canvas.pen.color := clWindowText //clHighlight// ;//;cl FCheckColor
    else
      canvas.pen.color := clBtnShadow;
    canvas.penpos := Point(CheckboxRect.left+3, CheckboxRect.top+5);
    canvas.lineto(CheckboxRect.left+7, CheckboxRect.top+9);
    canvas.penpos := Point(CheckboxRect.left+3, CheckboxRect.top+6);
    canvas.lineto(CheckboxRect.left+6, CheckboxRect.top+9);
    canvas.penpos := Point(CheckboxRect.left+3, CheckboxRect.top+7);
    canvas.lineto(CheckboxRect.left+6, CheckboxRect.top+10);
    canvas.penpos := Point(CheckboxRect.left+9, CheckboxRect.top+3);
    canvas.lineto(CheckboxRect.left+5, CheckboxRect.top+7);
    canvas.penpos := Point(CheckboxRect.left+9, CheckboxRect.top+4);
    canvas.lineto(CheckboxRect.left+5, CheckboxRect.top+8);
    canvas.penpos := Point(CheckboxRect.left+9, CheckboxRect.top+5);
    canvas.lineto(CheckboxRect.left+6, CheckboxRect.top+8);
  end;
  // Border
  canvas.brush.color := clBtnShadow;//  FBorderColor;
  canvas.FrameRect( CheckboxRect );
end;

procedure TcoCheckBox.DrawCheckText;
var
  TextBounds: TRect;
  Format: UINT;
begin
  Format := DT_WORDBREAK;
  case FLayout of
    checkboxLeft:
    begin
      TextBounds := Rect(ClientRect.Left + 16, ClientRect.Top + 1, ClientRect.Right - 1, ClientRect.Bottom - 1);
      Format := Format or DT_LEFT;
    end;
    checkboxRight:
    begin
      TextBounds := Rect(ClientRect.Left + 1, ClientRect.Top + 1, ClientRect.Right - 16, ClientRect.Bottom - 1);
      Format := Format or DT_RIGHT;
    end;
  end;

  with Canvas do
  begin
    Brush.Style := bsClear;
    Font := Self.Font;
(*    if not Enabled then
    begin
      OffsetRect(TextBounds, 1, 1);
      Font.Color := clBtnHighlight;
      DrawText(Handle, PChar(Caption), Length(Caption), TextBounds, Format);
      OffsetRect(TextBounds, -1, -1);
      Font.Color := clBtnShadow;
      DrawText(Handle, PChar(Caption), Length(Caption), TextBounds, Format);
    end
    else*)
      DrawText(Handle, PChar(Caption), Length(Caption), TextBounds, Format);
  end;
end;

procedure TcoCheckBox.Paint;
begin
  DrawCheckRect;
  DrawCheckText;
end;

(*procedure TcoCheckBox.MouseTimerHandler (Sender: TObject);
var
  P: TPoint;
begin
  GetCursorPos (P);
  if FindDragTarget(P, True) <> Self then
    MouseLeave;
end;

procedure TcoCheckBox.RemoveMouseTimer;
begin
  if MouseInControl = Self then
  begin
    MouseTimer.Enabled := False;
    MouseInControl := nil;
  end;
end;       *)

//==================================================================================================
{  }
//==================================================================================================
{procedure Register;
begin
  RegisterComponents( 'Comming Flat', [ TcoCheckBox ] );
  RegisterComponentEditor( TcoCheckBox, TcoBindingMenu );
end;}
//==================================================================================================
end.
