{===================================================================================================

  Comming Library

      .

====================================================================================================

  :

  12.11.2008 [*]       .
  30.08.2003 [+] WriteLog:  ,    .
  14.11.2002 [+]     .
  22.07.2002 [*]   .
  08.07.2002 [+]  .  .
  09.09.1998 [!]  Comming Library.

====================================================================================================
  Copyright 19982008 TSK Developer Laboratory, Moscow.               Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingLog.pas,v 1.8 2008/11/13 07:24:10 tsk Exp $
===================================================================================================}
unit CommingLog;

interface

  uses  Classes, Controls, Forms, SysUtils, CommingString, CommingFile;

  procedure WriteLog( Message: String = '*' ); overload;
  procedure WriteLog( Message: String; const Args: array of const ); overload;

  //      :
  procedure WriteLogFormName;


  var LogName: String;

implementation
//==================================================================================================
procedure WriteLog( Message: String );
  var Log: TextFile;
begin
  AssignFile( Log, LogName );
  if FileExists( LogName) then begin
    Append( Log )
  end else begin
    Rewrite( Log );
    Writeln( Log, '  ' + Application.Title + ' ' + DateToStr( Now ) );
  end;
  Writeln( Log, '');
  Writeln( Log, TimeToStr( Now ) + ' ]'+ Replicate( '-', 70 ));
  Writeln( Log, Message );
  CloseFile( Log );
end;
//==================================================================================================
procedure WriteLog( Message: String; const Args: array of const );
begin
  WriteLog( Format( Message, Args ));
end;
//==================================================================================================
procedure WriteLogFormName;
  var S: String;
      i: Integer;
begin
  S := '  :'#13#10;
  for i := 0 to Screen.FormCount - 1 do S := S + Screen.Forms[i].Name + ' (' + Screen.Forms[i].ClassName + ')'#13#10;
  WriteLog( S );
end;
//==================================================================================================
initialization
  LogName := ChangeFileExt( Application.ExeName, FormatDateTime('YYMMDD', Now) + '.log' );
//==================================================================================================
end.
