{===================================================================================================

  Comming Library

          .

====================================================================================================

  :

  25.07.2007  [*]     40 .
              [*]     .
              [*]    .
  11.02.2004  [+]  .
  02.02.2004  [*]   in.
  30.01.2004  [+]   in.
  24.07.2003  [*]  ,    .
  22.07.2003  [+]   Serge Gavrilov.
  09.09.1998  [!]  Comming Library.

====================================================================================================
  Copyright 19982007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingProjectSourceSort.pas,v 1.9 2007/08/17 07:53:17 tsk Exp $
===================================================================================================}
unit CommingProjectSourceSort;

interface

{$warn UNIT_DEPRECATED off}

{$I-}

uses  SysUtils, Classes, Controls, Windows, ExptIntf, ComCtrls, CommCtrl,
      // Comming
      CommingDialog, CommingOther, CommingString;

type
  TcoProjectSourceSort = class( TIExpert )
  public
    function  GetName: String; override; stdcall;
    function  GetAuthor: String; override; stdcall;
    function  GetComment: String; override; stdcall;
    function  GetPage: string; override; stdcall;
    function  GetGlyph: HICON; override; stdcall;
    function  GetStyle: TExpertStyle; override; stdcall;
    function  GetState: TExpertState; override; stdcall;
    function  GetIDString: string; override; stdcall;
    function  GetMenuText: string; override; stdcall;
    procedure Execute; override; stdcall;
  end;

procedure Register;

implementation
//==================================================================================================
{ TcoProjectSourceSort }
//==================================================================================================
function TcoProjectSourceSort.GetName;
begin
  Result := 'TcoProjectSourceSort';
end;
//==================================================================================================
function TcoProjectSourceSort.GetAuthor;
begin
  Result := 'Copyright 19982007 TSK Developer Laboratory, Moscow.';
end;
//==================================================================================================
function TcoProjectSourceSort.GetComment;
begin
  Result := '      .';
end;
//==================================================================================================
function TcoProjectSourceSort.GetGlyph;
begin
  Result := 1;
end;
//==================================================================================================
function TcoProjectSourceSort.GetPage;
begin
  Result := 'Comming';
end;
//==================================================================================================
function TcoProjectSourceSort.GetStyle;
begin
  Result := esStandard;
end;
//==================================================================================================
function TcoProjectSourceSort.GetState;
begin
  Result := [ esEnabled ];
end;
//==================================================================================================
function TcoProjectSourceSort.GetIDString;
begin
  Result := 'Comming expert';
end;
//==================================================================================================
function TcoProjectSourceSort.GetMenuText;
begin
  Result := '  ';
end;
//==================================================================================================
function UnitSort( List: TStringList; Index1, Index2: Integer): Integer;
  var P1, P2: String;
      i1, i2: Integer;
begin
  i1 := Pos( ' in ', List[Index1] );
  i2 := Pos( ' in ', List[Index2] );
  if i1 > 0
    then P1 := Copy( List[Index1], i1 + 5, Length(List[Index1]))
    else P1 := '....' + List[Index1];
  if i2 > 0
    then P2 := Copy( List[Index2], i2 + 5, Length(List[Index2]))
    else P2 := '....' + List[Index2];
  if P1 > P2 then Result := 1
  else if P1 < P2 then Result := -1
  else Result := 0;
end;
//==================================================================================================
procedure TcoProjectSourceSort.Execute;
  var SecProg, SecUses, SecRun: TStringList;
      Proj: TextFile;
      Error, i, p, CM, CB, Ind: Integer;
      ProjName: String;
      Line, s: String;

  function ReadProg: Boolean;   //   .
  begin
    Result := True;
    while not Eof( Proj ) do begin
      ReadLn( Proj, Line );
      SecProg.Add( Line );
      if Line = 'uses' then Exit;
    end;
    Result := False;
  end;

  function ReadUses: Boolean;   //    .
    var i: Integer;
  begin
    Result  := True;
    CM      := 0;
    CB      := 0;
    Ind     := 0;
    while not Eof( Proj ) do begin
      ReadLn( Proj, Line );
      Line := Trim( Line );
      i := Pos( ' in ', Line );
      // .
      if ( i > 0 ) then if Pos( '\BASE', UpperCase( Line )) > 0 then Inc( CB ) else Inc( CM );
      p := Length ( Trim ( Copy ( Line, 1, i - 1 ))); //    .
      if p > Ind then Ind := p;
      SecUses.Add( Line );
      if Copy( Line, Length( Line ), 1 ) = ';' then Exit; //  .
    end;
    Result := False;
  end;

  procedure ReadRun;            //   begin..end.
  begin
    while not Eof( Proj ) do begin
      ReadLn( Proj, Line );
      if Pos( 'Total', Line ) = 0 then SecRun.Add( Line );
    end;
  end;

begin
  SecProg := TStringList.Create;
  SecUses := TStringList.Create;
  SecRun  := TStringList.Create;
  try
    ProjName := ToolServices.GetProjectName;
    if Empty( ProjName ) then begin
      ShowStop( '   .' );
      Exit;
    end;
    ToolServices.SaveProject;
    AssignFile( Proj, ProjName );
    Reset( Proj );
    Error := IOResult;
    if Error <> 0 then begin
      ShowStop( ' (: %d)   %s.', [ Error, ProjName ]);
      Exit;
    end;

    if not ReadProg then begin
      ShowStop( '   %s    uses', [ ProjName ]);
      Exit;
    end;

    if not ReadUses then begin
      ShowStop( '   %s    begin..end', [ ProjName ]);
      Exit;
    end;

    SecUses.CustomSort( UnitSort );

    ReadRun;

  finally
    CloseFile( Proj );
  end;
  try
    AssignFile( Proj, ProjName );
    ReWrite( Proj ); Error := IOResult;
    if Error <> 0 then begin
      ShowStop( ' (: %d)   %s  .', [ Error, ProjName ]);
      Exit;
    end;
    for i := 0 to SecProg.Count - 1 do begin
      Line := SecProg[i];
      WriteLn( Proj, Line );
    end;
    for i := 0 to SecUses.Count - 1 do begin
      Line := SecUses[i];
      p := Pos( ' in ', Line );
      if p > 0 then begin
        s := Trim( Copy ( Line, 1, p - 1 ));
        Line := s + Space( Ind - Length( s )) + Copy( Line, p, Length( Line ));
      end;
      if i = ( SecUses.Count - 1)
        then Line[Length( Line )] := ';'
        else Line[Length( Line )] := ',';
      WriteLn( Proj, '  ' + Line );
    end;
    WriteLn( Proj, '  ' + Format( '{ Total: %d customer modules, %d base modules }', [ CM, CB ]));
    for i := 0 to SecRun.Count - 1 do begin
      Line := SecRun[i];
      WriteLn( Proj, Line );
    end;
  finally
    CloseFile( Proj );
    SecProg.Free;
    SecUses.Free;
    SecRun.Free;
    ToolServices.ReloadFile( ProjName );
  end;
end;
//==================================================================================================
procedure Register;
begin
  RegisterLibraryExpert( TcoProjectSourceSort.Create );
end;
//==================================================================================================
end.
