{=======================================================================================================================

  Comming Library

      .

========================================================================================================================

  :

  09.11.2013 [*] ReplaceQuotation:    - .
  07.05.2013 [+] ReplaceBracket:    .
             [*] QuotationReplace  ReplaceQuotation.
  12.03.2013 [+] PosAfter:      .
  05.11.2012 [*] DelDoubleChar:     .
  25.10.2012 [+] HTMLDeleteComments, HTMLDeleteTag, HTMLReplaceSymbol -  HTML.
  23.10.2012 [+] UpperFirstLetterSentence:  ,   .
  29.01.2012 [*] UpperFirstLetterWord:     .
             [-] ReplaceStr:  StringReplace  unit StrUtils.
             [+] QuotationReplace:       .
  08.12.2011 [*] UpperFirstLetterWord:    "-".
  23.09.2010 [*] StringListTrimUpperFirstLetter:   .
  22.09.2010 [+] StringListTrimUpperFirstLetter:     .
  24.07.2010 [+] TransRusLatinFamily:      394  30.06.98.
  30.01.2010 [+] PosChar:      .
  07.10.2009 [-] RightString:  RightStr  unit StrUtils.
  24.07.2008 [*] TildeToAscii:  .
  25.09.2008 [+] CutLeftString:   .
  17.05.2008 [+] TransLatinRus:  .
  26.10.2007 [-] StdWordDelims:   ,   .
  22.05.2007 [*]   StringListTrim, StringListEmptyEnd.
             [+] StringListAddFormat:     .
  02.03.2007 [*] TildeToAscii:         ASCII.
  23.02.2007 [+] IsTilde:     .
             [+] TildeToAscii:        ASCII.
  22.07.2006 [*] TransLatin:  .
  24.08.2005 [-] LeftString:  LeftStr  unit StrUtils.
  17.08.2005 [+] RightStringDelete:     .
  07.01.2005 [+] EmptyEndStringList:      .
             [+] TrimStringList:         .
  07.05.2004 [+] UpperFirstLetterWord:     ,  .
  23.01.2003 [-]  TAB.
  09.02.2002 [+] CharCount:      .
  26.09.2001 [+] ClearChars:      .
             [+]  .
  03.09.2001 [+] ReplaceStr:    .
             [+] EmptyCharString:     ,  .
  29.05.2001 [*] DeleteChars:    .
  19.11.2000 [*]      .
             [+]       .
  15.06.1999 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingString.pas,v 1.40 2013/11/11 05:05:46 tsk Exp $
=======================================================================================================================}
unit CommingString;

interface

  uses SysUtils, Windows, Classes, CommingOther;

  const
    CRLF = #13#10;
    DigitChars = ['0'..'9'];
    Brackets = ['(', ')', '[', ']', '{', '}'];
    StdWordDelims = [#0..' ', ',' , '.' , ';', '/', '\', ':', '"', '`'] + Brackets;
    ClearChar = '"''()[]{}?!`';
    Quotations = '''"';

  function  DelChar( const S: string; Chr: Char ): string;
  function  DelDoubleChar( const S: string; Chr: Char ): string;
  function  DeleteChars( Source: String; Chars: String = ClearChar; DoubleChars: String = ' ' ): String;
  function  ClearChars( Source: String; Chars: String = ClearChar; ClearChar: Char = ' ' ): String;
  function  CharCount( C, S: String ): Integer;
  function  NPos( C, S: string; N: Integer): Integer;
  function  PosChar( Chars, S: string; Offset: Cardinal = 1): Integer;
  function  PosAfter( Substr, S: String ): Integer;
  function  StrCheckSum( Text: String; Len: Integer ): String;
  function  Pad( InString: String; Len: Integer ): String;
  function  LPad( InString: String; Len: Integer ): String;
  function  Replicate( Ch: Char; Len: Integer ): String;
  function  Space( Len: Integer ): String;
  function  RightStringDelete(InString: String; Len: Integer): String;
  function  CutLeftString(InString: String; Len: Integer): String;
  function  SortString( sVal: String ): String ;
  function  MoneyToDigString( cMoney: Currency): String;
  function  CurrencyToStr( Value: Currency): String;
  function  FloatToSQL( Value: Extended ): String;
  function  DecodeParol( Parol: String ): String;
  function  EncodeParol( Parol: String ): String;
  function  AddStringWithDelim( Base, Addition: String; Delim: String = ' ' ): String;
  function  TransRusLatin( Source: String ): String;
  function  TransRusLatinFamily( Source: String ): String;
  function  TransLatinRus( Source: String ): String;
  function  StrToOem(const AnsiStr: String): String;
  function  IsInRussian( Text: String ): Boolean;
  function  EmptyCharString( Str: String; EmptyChars: TSysCharSet ): Boolean;
  function  UpperFirstLetterWord( Str: String): String;
  function  UpperFirstLetterSentence( Str: String): String;
  function  IsTilde( Text: String ): Integer;
  function  TildeToAscii( Str: String): String;
  function  ReplaceQuotation( Str: String): String;
  function  ReplaceBracket( Str: String): String;

  procedure StringListTrim( var Text: TStringList );
  procedure StringListEmptyEnd( var Text: TStringList );
  procedure StringListAddFormat( List: TStringList; FormStr: String; const Args: array of const );
  procedure StringListTrimUpperFirstLetter( var Text: TStringList );

  //HTML:
  function HTMLDeleteComments( HTML: String ): String;
  function HTMLDeleteTag(HTML: String): String;
  function HTMLReplaceSymbol(HTML: String): String;

implementation
//======================================================================================================================
function DelChar( const S: string; Chr: Char ): string;
  var i: Integer;
begin
  Result := S;
  for i := Length( Result ) downto 1 do
    if Result[i] = Chr
      then Delete( Result, i, 1 );
end;
//======================================================================================================================
function DelDoubleChar( const S: string; Chr: Char ): string;
  var i: Integer;
begin
  Result := S;
  for i := Length( Result ) downto 2 do
    if ( Result[ i ] = Chr ) and ( Result[ i - 1 ] = Chr ) then Delete( Result, i, 1 );
end;
//======================================================================================================================
function DeleteChars( Source, Chars, DoubleChars: String ): String;
  var i: Integer;
begin
  Result := Source;
  for i := 1 to Length( Chars ) do Result := DelChar( Result, Chars[i] );
  for i := 1 to Length( DoubleChars ) do Result := DelDoubleChar( Result, DoubleChars[i] );
end;
//======================================================================================================================
function  ClearChars( Source, Chars: String; ClearChar: Char ): String;
  var i: Integer;
begin
  Result := Source;
  for i := 1 to Length( Result ) do begin
    if Pos( Result[i], Chars ) > 0 then Result[i] := ClearChar;
  end;
end;
//======================================================================================================================
function StrCheckSum( Text: String; Len: Integer ): String;
  var i, s, l: Integer;
begin
  s := 0;
  l := Length( Text );
  for i := 1 to l do s := s + Ord( Text[ i ]);
  Result := IntToHex( s, Len );
  l := Length( Result );
  if l > Len then Result := Copy( Result, l - Len + 1, Len );
end;
//=============================================================================================
function Pad( InString: String; Len: Integer ): String;
begin
  Result := Format( '%-*s', [Len, InString] );
end;
//=============================================================================================
function LPad( InString: String; Len: Integer ): String;
begin
  Result := Format( '%*s', [Len, InString] );
end;
//=============================================================================================
function  RightStringDelete(InString: String; Len: Integer): String;
begin
  Result := Copy( InString, 1, Length( InString ) - Len );
end;
//=============================================================================================
function  CutLeftString(InString: String; Len: Integer): String;
begin
  Result := Copy( InString, Len + 1, Length( InString ) - Len );
end;
//=============================================================================================
function Replicate( Ch: Char; Len: Integer ): String;
begin
  SetLength( Result, Len );
  FillChar( Result[1], Len, Ch );
end;
//=============================================================================================
function Space( Len: Integer ): String;
begin
  Result := Replicate( ' ', Len);
end;
//=============================================================================================
function Empty(InString: string): boolean;
begin
  Result := ( Length( InString ) = 0 ) or ( Trim( InString ) = '' );
end;
//=============================================================================================
function SortString( sVal: String ): String ;
  var lRepit: Boolean;
      iLen, i: Integer;
      b: Char;
      x: String;
begin
  x := sVal; iLen := Length( sVal ) - 1;
  repeat
    lRepit := False;
    for i := 1 to iLen do
      if x[ i ] > x[ i + 1 ] then
        begin
          lRepit := True;
          b := x[ i ]; x[ i ] := x[ i + 1 ]; x[ i + 1 ] := b;
        end;
  until not lRepit;
  Result := x;
end;
//=============================================================================================
function MoneyToDigString( cMoney: Currency): String;
  var p: Integer;
begin
  Result := Trim( FormatFloat( '### ### ### ##0.00', cMoney ));
  p := Pos( ',', Result );
  Delete( Result, p, 1 );
  Insert( ' . ', Result, p );
  Result := Result + ' .';
end;
//======================================================================================================================
function CurrencyToStr( Value: Currency ): String;
begin
  Result := Trim( FormatFloat( '### ### ### ##0.00', Value ));
  Result := Result + CurrencyString;
end;
//======================================================================================================================
function DecodeParol( Parol: String ): String;
  var i, xChar: Integer;
begin
  Parol   := Pad( Parol, 20 );
  Result  := '';
  for i := 9 downto 0 do begin
    xChar := StrToIntDef( '$' + Copy( Parol, i * 2 + 1, 2 ), 32 );
    if xChar <= 32 then xChar := 32;
    Result := Result + Chr( xChar );
  end;
  Result := Trim( Result );
end;
//======================================================================================================================
function EncodeParol( Parol: String ): String;
  var i, xChar: Integer;
begin
  Parol   := Pad( Parol, 10 );
  Result  := '';
  Randomize;
  for i := 10 downto 1 do begin
    xChar := Ord( Parol[i]);
    if xChar = 32 then xChar := Random( 32 );
    Result := Result + IntToHex( xChar, 2 );
  end;
end;
//======================================================================================================================
function AddStringWithDelim( Base, Addition, Delim: String ): String;
begin
  if Empty( Addition )
    then Result := Base
    else Result := iif ( Empty( Base ),
                         Addition,
                         Base + iif( Delim = ' ', Delim, Delim + ' ') + Addition );
end;
//======================================================================================================================
function TransRusLatin( Source: String ): String;
  var i: Integer;
  const Latin: array [1..64] of String
    = (  'A',  'B',  'V',  'G',  'D',  'E', 'Zh',  'Z',  'I',  'J',  'K',  'L',  'M',  'N',  'O',
     //                                                                         
         'P',  'R',  'S',  'T',  'U',  'F',  'H', 'Ts', 'Ch', 'Sh','Sch','''',   'Y','''',   'E',
     //                                                                         
        'Yu', 'Ya',  'a',  'b',  'v',  'g',  'd',  'e', 'zh',  'z',  'i',  'j',  'k',  'l',  'm',
     //                                                                         
         'n',  'o',  'p',  'r',  's',  't',  'u',  'f',  'h', 'ts', 'ch', 'sh','sch', '''',  'y',
     //                                                                         
        '''',  'e', 'yu', 'ya' );
     //                  
begin
  Result := '';
  for i := 1 to Length( Source ) do
    if Source[i] >= ''
      then Result := Result + Latin[ Ord( Source[i]) - 191 ]
      else if (Ord( Source[i]) = 168) then Result := Result + 'Io'
      else if (Ord( Source[i]) = 184) then Result := Result + 'io'
      else Result := Result + Source[i];
end;
//======================================================================================================================
function  TransRusLatinFamily( Source: String ): String;
  var i: Integer;
  const Latin: array [1..63, 1..2] of string = (
    ( '', 'vy'   ),
    ( '', 'gy'   ),
    ( '', 'dy'   ),
    ( '', 'ny'   ),
    ( '', 'sy'   ),
    ( '', 'ty'   ),
    ( '',  'zd'   ),
    ( '',  'ay'   ),
    ( '',  'ey'   ),
    ( '',  'ey'   ),
    ( '',  'iy'   ),
    ( '',  'ia'   ),
    ( '',  'oy'   ),
    ( '',  'uy'   ),
    ( '',  'uy'   ),
    ( '',  'ey'   ),
    ( '',  'ia'   ),
    ( '',  'ye'   ),
    ( '',  'ye'   ),
    ( '',  'ia'   ),
    ( '',  'yi'   ),
    ( '',  'yo'   ),
    ( '',  'yu'   ),
    ( '',  'yy'   ),
    ( '',  'ye'   ),
    ( '',  'yu'   ),
    ( '',  'x'    ),
    ( '',  'yuy'  ),
    ( '',  'yay'  ),
    ( '',  'liu'  ),
    ( '',   'zh'   ),
    ( '',   'kh'   ),
    ( '',   'ts'   ),
    ( '',   'ch'   ),
    ( '',   'sh'   ),
    ( '',   'ya'   ),
    ( '',   'yu'   ),
    ( '',   'shch' ),
    ( '',   ''     ),
    ( '',   ''     ),
    ( '',   'a'    ),
    ( '',   'b'    ),
    ( '',   'v'    ),
    ( '',   'g'    ),
    ( '',   'd'    ),
    ( '',   'e'    ),
    ( '',   'e'    ),
    ( '',   'z'    ),
    ( '',   'i'    ),
    ( '',   'y'    ),
    ( '',   'k'    ),
    ( '',   'l'    ),
    ( '',   'm'    ),
    ( '',   'n'    ),
    ( '',   'o'    ),
    ( '',   'p'    ),
    ( '',   'r'    ),
    ( '',   's'    ),
    ( '',   't'    ),
    ( '',   'u'    ),
    ( '',   'f'    ),
    ( '',   'y'    ),
    ( '',   'e'    )
    );
begin
  Result := AnsiLowerCase( Source );
  for i := 1 to High( Latin )
    do Result := StringReplace( Result, Latin[ i, 1 ], Latin[ i, 2], [ rfReplaceAll ]);
  Result := UpperFirstLetterWord( Result );
end;
//======================================================================================================================
function TransLatinRus( Source: String ): String;
  var i: Integer;
  const Latin: array [1..58] of String
    = ( '','','','','','','','','','','','','','','','','?','','','','',
     //  A   B   C   D   E   F   G   H   I   J   K   L   M   N   O   P   Q   R   S   T   U
        '','?','?','','','?','?','?','?','?','?',
     //  V   W   X   Y   Z
        '','','','','','','','','','','','','','','','','?','','','','',
     //  A   B   C   D   E   F   G   H   I   J   K   L   M   N   O   P   Q   R   S   T   U
        '','?','?','','' );
     //  V   W   X   Y   Z
         ManyLat: array [0..31] of String
     = ( 'Sch', '',
         'sch', '',
         'Ch',  '',
         'ch',  '',
         'Zh',  '',
         'zh',  '',
         'Ts',  '',
         'ts',  '',
         'Sh',  '',
         'sh',  '',
         'Yu',  '',
         'yu',  '',
         'Ya',  '',
         'ya',  '',
         'Ja',  '',
         'ja',  ''
          );
begin
  for i := 0 to 15 do
    Source := StringReplace( Source, ManyLat[i*2], ManyLat[i*2+1], [rfReplaceAll]);
  Result := '';
  for i := 1 to Length( Source ) do
    if ( Source[i] >= 'A' ) and ( Source[i] <= 'z' )
      then Result := Result + Latin[ Ord( Source[i]) - 64 ]
      else Result := Result + Source[i];
end;
//======================================================================================================================
function  IsInRussian( Text: String ): Boolean;
  var i: Integer;
begin
  Result := False;
  for i := 1 to Length( Text ) do
    if Ord( Text[i] ) >= 192 then begin
      Result := True;
      Exit;
    end;
end;
//======================================================================================================================
function StrToOem(const AnsiStr: String): String;
begin
  SetLength(Result, Length(AnsiStr));
  if Length(Result) > 0 then
    CharToOemBuff(PChar(AnsiStr), PChar(Result), Length(Result));
end;
//======================================================================================================================
function EmptyCharString( Str: String; EmptyChars: TSysCharSet ): Boolean;
  var i: Integer;
begin
  for i := 1 to Length( Str ) do
    if not ( Str[I] in EmptyChars ) then begin
      Result := False;
      Exit;
    end;
  Result := True;
end;
//======================================================================================================================
function CharCount( C, S: String ): Integer;
  var i: Integer;
begin
  Result := 0;
  for i := 1 to Length(S) do if S[i] = C then Inc( Result );
end;
//======================================================================================================================
function NPos( C, S: string; N: Integer): Integer;
  var I, P, K: Integer;
begin
  Result := 0;
  K := 0;
  for I := 1 to N do begin
    P := Pos(C, S);
    Inc(K, P);
    if (I = N) and (P > 0) then begin
      Result := K;
      Exit;
    end;
    if P > 0 then Delete(S, 1, P)
    else Exit;
  end;
end;
//======================================================================================================================
function PosChar( Chars, S: string; Offset: Cardinal = 1): Integer;
  var i: Integer;
begin
  Result := 0;
  for i := 1 to length( S ) do
    if Pos( S[i], Chars ) > 0 then begin
      Result := i; Exit;
    end;
end;
//======================================================================================================================
function PosAfter( Substr, S: String ): Integer;
begin
  Result := Pos( Substr, S );
  if Result > 0 then Result := Result + Length( Substr );
end;
//======================================================================================================================
function FloatToSQL( Value: Extended ): String;
  var OldSep: Char;
begin
  OldSep := DecimalSeparator;
  DecimalSeparator := '.';
  Result := FloatToStr( Value );
  DecimalSeparator := OldSep;
end;
//======================================================================================================================
function UpperFirstLetterWord( Str: String): String ;
  var i: Integer;
      u: Boolean;
begin
  Result := AnsiLowerCase( Str );
  u := True;
  for i := 1 to Length( Result ) do begin
    if ( Result[i] in StdWordDelims + [ '-', '', '' ] )
      then u := True
      else if u then begin Result[i] := AnsiUpperCase(Result[i])[1]; u := False end;
  end;
end;
//======================================================================================================================
function UpperFirstLetterSentence( Str: String): String;
  var i: Integer;
begin
  Result := AnsiLowerCase( Str );
  Result[1] := AnsiUpperCase(Result[1])[1];
  for i := 1 to Length( Result ) do if ( Result[i] = '.' ) then Result[i + 2] := AnsiUpperCase(Result[i + 2])[1];
end;
//======================================================================================================================
function  IsTilde( Text: String ): Integer;
  var i: Integer;
begin
  Result := -1;
  for i := 1 to Length( Text ) do
    if ( Text[i] >= #$7E ) then begin Result := i; Exit; end;
end;
//======================================================================================================================
function TildeToAscii( Str: String): String ;
  var i, p: Integer;
  const sTilde = #$60+
                 #$8E+
                 #$9A+
                 #$C0#$C1#$C2#$C3#$C4#$C5#$C6#$C7#$C8#$C9#$CA#$CB#$CC#$CD#$CE#$CF+
                 #$D6+#$DC+
                 #$E0#$E1#$E2#$E3#$E4#$E5#$E6#$E7#$E8#$E9#$EA#$EB#$EC#$ED#$EE#$EF+
                 #$F0#$F1#$F2#$F3#$F4#$F5#$F6#$F7#$F8#$F9#$FA#$FB#$FC#$FD#$FE#$FF;
        sASCII = #$27+
                 #$5A+
                 #$73+
                 #$41#$41#$41#$41#$41#$41#$C6#$43#$45#$45#$45#$45#$49#$49#$49#$49+
                 #$4f+#$55+
                 #$61#$61#$61#$61#$61#$61#$E6#$63#$65#$65#$65#$65#$69#$69#$69#$69+
                 #$F0#$6E#$6F#$6F#$6F#$6F#$6F#$F7#$6F#$75#$75#$75#$75#$79#$70#$79;
  procedure RP( var Str: String; Sub: String; Pos: Integer );
  begin
   Delete( Str, Pos, 1 );
   Insert( Sub, Str, Pos );
  end;
begin
  Result := Str;
  for i := 1 to Length( Str ) do begin
    p := Pos( Result[i], sTilde );
    if p > 0 then Result[i] := sASCII[p];
    case Result[i] of
      #$E6: RP( Result, 'ae',   i );
      #$C6: RP( Result, 'Ae',   i );
      #$DF: RP( Result, 'ss',   i );
    end;
  end;
end;//==================================================================================================================
procedure StringListTrim( var Text: TStringList );
  var i: Integer;
begin
  for i := 0 to Text.Count - 1 do Text[i] := Trim( Text[i] )
end;
//======================================================================================================================
function ReplaceQuotation( Str: String ): String;
begin
  Result := Str;
  //  :
  Result := ClearChars( Result, Quotations );
  Result := '' + Trim( Result ) + '';
end;
//======================================================================================================================
function ReplaceBracket( Str: String): String;
begin
  Result := Str;
  Result := StringReplace( Result, '[', '(', [ rfReplaceAll ]);
  Result := StringReplace( Result, ']', ')', [ rfReplaceAll ]);
end;
//======================================================================================================================
{ StringList }
//======================================================================================================================
procedure StringListTrimUpperFirstLetter( var Text: TStringList );
  var i: Integer;
begin
  for i := 0 to Text.Count - 1
    do if Length(Text[i])> 0
        then Text[i] :=  AnsiUpperCase(Text[i][1]) + Copy( Text[i], 2, Length(Text[i]));
end;
//======================================================================================================================
procedure StringListEmptyEnd( var Text: TStringList );
begin
  while ( Text.Count > 0 ) and ( Length( Text[Text.Count-1] ) = 0 )
    do Text.Delete(Text.Count-1);
end;
//======================================================================================================================
procedure StringListAddFormat( List: TStringList; FormStr: String; const Args: array of const );
begin
  List.Add( Format( FormStr, Args ));
end;
//======================================================================================================================
{ HTML }
//======================================================================================================================
function HTMLDeleteComments( HTML: String ): String;
  var p0, p1: Integer;
begin
  while Pos( '<!--', HTML ) > 0 do begin
    p0 := Pos( '<!--', HTML );
    p1 := Pos( '-->', HTML );
    HTML := Copy( HTML, 1, p0 - 1) + Copy( HTML, p1 + 3, MaxInt )
  end;
  Result := HTML;
end;
//======================================================================================================================
function HTMLDeleteTag( HTML: String ): String;
  var p0, p1: Integer;
begin
  while Pos( '<', HTML ) > 0 do begin
    p0 := Pos( '<', HTML );
    p1 := Pos( '>', HTML );
    HTML := Copy( HTML, 1, p0 - 1) + Copy( HTML, p1 + 1, MaxInt )
  end;
  Result := HTML;
end;
//======================================================================================================================
function HTMLReplaceSymbol( HTML: String ): String;
begin
  HTML := StringReplace( HTML, '&nbsp;', #160, [ rfReplaceAll, rfIgnoreCase ]);
  Result := HTML;
end;
//======================================================================================================================
end.
