{ Release 5 is the work of Kurt Blide <kub@sam.sdu.dk>
  (old address is kub@busieco.ou.dk) }

{ Release 3 & 4 are updates by Jordan Russell

  Release 4 changes include:
  - Added the missing events that were on Delphi's original TDBNavigator,
    including OnClick and BeforeAction.
	- Updated my site address below :)

  Release 3 changes include:
  - Support for Toolbar97 1.65.
  - Problem with repeating buttons fixed.
	- Compiler warnings fixed. }

{Original source code for the DBNavigator (C) by Borland
*********************************************************
DBNavigator97 (Release 5)
*********************************************************
Source modified and enhanced for use with the Toolbar97 components
from Jordan Russell (http://www.digicron.com/jordanr/).

The DBNavigator97 works exactly like the original Delphi 2.0 DB Navigator.
When putting it on a Toolbar97,the buttons will be separated from each
other when running the application,and the toolbar can be resized with
correct "button wrapping" instead of keeping one unseparated block.

I didn't test it with Delphi 1. If there are problems I suppose they have
to do with the database implementation.

Expect for the original DBNavigator source parts by Borland,this source is
(C) by Arsne von Wyss (avonwyss@beaulieu-software.ch)}

unit CommingDBNavigator97;

interface

uses
  SysUtils,Windows,Messages,Classes,Controls,Forms,ExtCtrls,DB,DBTables,Buttons,DBCtrls,TB97,TB97Tlbr,TB97Ctls;

{ Determine Delphi/C++Builder version }
{$IFNDEF VER90}  { if it's not Delphi 2.0 }
	{$IFNDEF VER93}  { and it's not C++Builder 1.0 }
    {$DEFINE DBNav97Delphi3}  { then it must be Delphi 3 or C++Builder 3 }
		{$IFNDEF VER100}  { if it's not Delphi 3.0 }
			{$ObjExportAll On}  { <- needed for compatibility with run-time packages in C++Builder 3 }
			{$IFNDEF VER110}  { and it's not C++Builder 3.0 }
        {$DEFINE DBNav97Delphi4}  { then it must be at least Delphi 4 or C++Builder 4 }
      {$ENDIF}
		{$ENDIF}
	{$ENDIF}
{$ENDIF}

type
	TNavButton97=class;
	TNavDataLink97=class;

	TNavigateBtn97 = (nbFirst97, nbPgUp97, nbPrior97, nbNext97, nbPgDown97, nbLast97,
									nbInsert97, nbDelete97, nbEdit97, nbPost97, nbCancel97, nbRefresh97);
	TButtonSet97 = set of TNavigateBtn97;

	ENavClick97 = procedure (Sender: TObject; Button: TNavigateBtn97) of object;

{TcoDBNavigator97}
	TcoDBNavigator97=class(TCustomPanel)
	private
    FDataLink: TNavDataLink97;
		FVisibleButtons: TButtonSet97;
		FDisplayMode: TButtonDisplayMode;
		FHints: TStrings;
		FCaptions: TStrings;
		FWordWrap: Boolean;
		FLayout: TButtonLayout;
		FButtonWidth: Integer;
		MinBtnSize: TPoint;
		FOnNavClick: ENavClick97;
		FBeforeAction: ENavClick97;
		FocusedButton: TNavigateBtn97;
		FConfirmDelete,FOpaque: Boolean;
		FPageLen: Integer;
		FCanModifyField: TField;
		function 	GetDataSource: TDataSource;
    procedure SetDataSource(Value: TDataSource);
		procedure InitButtons;
    procedure InitHints;
		procedure InitCaptions;
    procedure SetCaptions(Value: TStrings);
		procedure SetDisplayMode (Value: TButtonDisplayMode);
		procedure SetWordWrap (Value: Boolean);
		procedure InitFont;
		procedure ClickHandler(Sender: TObject);
		procedure BtnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
		procedure SetVisible(Value: TButtonSet97);
//		procedure SetBtnEnabled(Value: TButtonSet97);
		procedure SetSize(var W: Integer; var H: Integer);
    procedure SetHints(Value: TStrings);
		procedure SetOpaque(Value: Boolean);
		procedure SetLayout (Value: TButtonLayout);
		procedure WMSize(var Message: TWMSize);  message WM_SIZE;
		procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
		procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
		procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
		procedure WMEraseBackground(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
		procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
		procedure SetButtonWidth(const Value: Integer);
		function GetCanModifyFieldName: String;
		procedure SetCanModifyFieldName(const Value: String);
	protected
		Buttons: array[TNavigateBtn97] of TNavButton97;
		procedure DataChanged;
		procedure EditingChanged;
		procedure ActiveChanged;
		procedure Loaded; override;
		procedure KeyDown(var Key: Word; Shift: TShiftState); override;
		procedure Notification(AComponent: TComponent; Operation: TOperation); override;
		procedure GetChildren(Proc: TGetChildProc {$IFDEF DBNav97Delphi3}; Root: TComponent {$ENDIF}); override;
		procedure SetParent(AParent: TWinControl); override;
	public
		constructor Create(AOwner: TComponent); override;
		destructor Destroy; override;
		procedure SetBounds(ALeft,ATop,AWidth,AHeight: Integer); override;
		procedure BtnClick(Index: TNavigateBtn97);
		property	CanModifyField: TField read FCanModifyField write FCanModifyField;
	published
		property 	CanModifyFieldName: String read GetCanModifyFieldName write SetCanModifyFieldName;
		property PageLen: Integer read FPageLen write FPageLen default 10;
		property ButtonWidth: Integer read FButtonWidth write SetButtonWidth default 25;
		property DataSource: TDataSource read GetDataSource write SetDataSource;
		property VisibleButtons: TButtonSet97 read FVisibleButtons write SetVisible default [nbFirst97, nbPgUp97, nbPrior97, nbNext97, nbPgDown97, nbLast97, nbInsert97, nbDelete97, nbEdit97, nbPost97, nbCancel97, nbRefresh97 ];
		property Opaque: Boolean read FOpaque write SetOpaque default True;
		property Align;
		property Enabled;
		property Hints: TStrings read FHints write SetHints;
		property Captions: TStrings read FCaptions write SetCaptions;
		property DisplayMode: TButtonDisplayMode read FDisplayMode write SetDisplayMode default dmBoth;
		property WordWrap: Boolean read FWordWrap write SetWordWrap default True;
		property Layout: TButtonLayout read FLayout write SetLayout default blGlyphLeft;
		property ParentShowHint;
		property PopupMenu;
		property ConfirmDelete: Boolean read FConfirmDelete write FConfirmDelete default True;
		property ShowHint;
		property Visible;
		property Font;
		property BeforeAction: ENavClick97 read FBeforeAction write FBeforeAction;
		property OnClick: ENavClick97 read FOnNavClick write FOnNavClick;
		property OnDblClick;
		property OnDragDrop;
		property OnDragOver;
		{$IFDEF DBNav97Delphi4}
		property OnEndDock;
		{$ENDIF}
		property OnEndDrag;
		property OnEnter;
		property OnExit;
		property OnResize;
		{$IFDEF DBNav97Delphi4}
		property OnStartDock;
		{$ENDIF}
		property OnStartDrag;
	end;

{TNavButton97}
	TNavButton97=class(TToolbarButton97)
	private
		FIndex: TNavigateBtn97;
	protected
    procedure Paint; override;
  public
		property Index : TNavigateBtn97 read FIndex write FIndex;
	end;

{TNavDataLink97}
	TNavDataLink97=class(TDataLink)
	private
		FNavigator: TcoDBNavigator97;
  protected
    procedure EditingChanged; override;
    procedure DataSetChanged; override;
    procedure ActiveChanged; override;
  public
		constructor Create(ANav: TcoDBNavigator97);
		destructor Destroy; override;
	end;

procedure Register;

resourcestring
	SFirstRecord 					= ' ';
	SPgUpRecord 					= ' ';
	SPriorRecord 					= ' ';
	SNextRecord 					= ' ';
	SPgDownRecord					= ' ';
	SLastRecord 					= ' ';
	SInsertRecord					= ' ';
	SDeleteRecord	 				= ' ';
	SEditRecord 					= ' ';
	SPostEdit 						= ' ';
	SCancelEdit 					= ' ';
	SRefreshRecord 				= ' ';
	SDeleteRecordQuestion = '  ?';

implementation

{$R CommingDBNavigator97.Res}

uses
	BDE,Clipbrd,DBConsts,Dialogs;

{TcoDBNavigator97}

const
	BtnTypeName: array[TNavigateBtn97] of PChar=('FIRST','PGUP','PRIOR','NEXT',
			'PGDOWN','LAST','INSERT','DELETE','EDIT','POST','CANCEL','REFRESH');

	BtnHintId: array[TNavigateBtn97] of {$IFNDEF DBNav97Delphi3}Word{$ELSE}String{$ENDIF}=(SFirstRecord,SPgUpRecord,SPriorRecord,SNextRecord,SPgDownRecord,SLastRecord,
			SInsertRecord,SDeleteRecord,SEditRecord,SPostEdit,SCancelEdit,SRefreshRecord);

procedure TcoDBNavigator97.SetParent(AParent: TWinControl);
var
	I: TNavigateBtn97;
begin
	inherited;
	if not (csDesigning in ComponentState) then
		for I:=High(Buttons) downto Low(Buttons) do
			with Buttons[I] do begin
				Visible:=False;
				Top:=Top;
				Left:=Left;
				Parent:=self.Parent;
				Visible:=True;
			end;
end;

{procedure TcoDBNavigator97.SetBtnEnabled(Value: TButtonSet97);
var
	I: TNavigateBtn97;
begin
	FEnabledButtons:=Value;
	for I:=Low(Buttons) to High(Buttons) do
		Buttons[I].Enabled:=I in Value;
	Invalidate;
end;
}
procedure TcoDBNavigator97.SetOpaque(Value: Boolean);
var
  I: TNavigateBtn97;
begin
  if Value<>FOpaque then begin
    FOpaque:=Value;
		if Value then
			ControlStyle := ControlStyle + [csOpaque]
    else
      ControlStyle := ControlStyle - [csOpaque];
    for I:=Low(Buttons) to High(Buttons) do
			Buttons[I].Opaque:=Value;
    Invalidate;
  end;
end;

procedure TcoDBNavigator97.WMEraseBackground(var Message: TWMEraseBkgnd);
begin
end;

constructor TcoDBNavigator97.Create(AOwner: TComponent);
begin
	inherited;
	ControlStyle := ControlStyle - [csAcceptsControls, csSetCaption] + [csOpaque];
	FDataLink := TNavDataLink97.Create(Self);
	FVisibleButtons :=[ nbFirst97, nbPgUp97, nbPrior97, nbNext97, nbPgDown97, nbLast97,
											nbInsert97, nbDelete97, nbEdit97, nbPost97, nbCancel97, nbRefresh97 ];
	FHints		:= TStringList.Create;
	FCaptions	:= TStringList.Create;
	FWordWrap				:= False;
	FOpaque					:= True;
	FLayout					:=	blGlyphLeft;
	FDisplayMode		:= dmGlyphOnly; 	// TSK
	ShowHint				:= True;
	BevelOuter			:= bvNone;
	BevelInner			:= bvNone;
	Width						:= 250; 					// TSK
	Height					:= 24; 						// TSK
	PageLen					:= 10; 						//TSK
	ButtonWidth			:= 25;
	InitButtons;
	FocusedButton		:= nbFirst97;
	FConfirmDelete	:= False;
	if not (csDesigning in ComponentState) then Visible:=False;
end;

destructor TcoDBNavigator97.Destroy;
begin
	FDataLink.Free;
	FHints.Free;
	FCaptions.Free;
	FDataLink:=nil;
	inherited;
end;

procedure TcoDBNavigator97.InitButtons;
var
	I: TNavigateBtn97;
	Btn: TNavButton97;
	X: Integer;
begin
	MinBtnSize := Point(25,24); //TSK
	X:=0;
	for I:=Low(Buttons) to High(Buttons) do begin
		Btn:=TNavButton97.Create(self);
		with Btn do begin
			if (csDesigning in ComponentState) then
				Parent:=Self;
			Index:=I;
			SetBounds(X,0,MinBtnSize.X,MinBtnSize.Y);

			{ Changed resource name, and added IFDEF }
			{$IFDEF DBNav97Delphi3}
			Glyph.LoadFromResourceName (HInstance, Format('dbn_%s97', [BtnTypeName[I]]));
			{$ELSE}
			Glyph.Handle:=LoadBitmap(HInstance,PChar(Format('dbn_%s97',[BtnTypeName[I]])));
			{$ENDIF}
			Visible	:= ( I in FVisibleButtons );
			NumGlyphs		:= 5; //TSK
			Opaque			:= FOpaque;
			Layout			:= FLayout;
			DisplayMode	:= FDisplayMode;
			Enabled			:= True;
			OnClick			:= self.ClickHandler;
			OnMouseDown	:= BtnMouseDown;
		end;
		Buttons[I] := Btn;
		X := X + MinBtnSize.X;
	end;
	InitHints;
	InitCaptions;
	InitFont;
	Buttons[nbPgUp97].Repeating 	:= True;
	Buttons[nbPrior97].Repeating 	:= True;
	Buttons[nbNext97].Repeating 	:= True;
	Buttons[nbPgDown97].Repeating	:= True;
end;

procedure TcoDBNavigator97.InitHints;
var
	I: Integer;
	J: TNavigateBtn97;
begin
	for J:=Low(Buttons) to High(Buttons) do begin
		Buttons[J].Hint:={$IFNDEF DBNav97Delphi3}LoadStr{$ENDIF}(BtnHintId[J]);
		Buttons[J].ShowHint:=ShowHint;
	end;
	J:=Low(Buttons);
	for I:=0 to (FHints.Count-1) do begin
		if FHints.Strings[I]<>'' then
			with Buttons[J] do begin
				Hint:=FHints.Strings[I];
				ShowHint:=self.ShowHint;
			end;
		if J=High(Buttons) then
			Exit;
		Inc(J);
	end;
end;

procedure TcoDBNavigator97.SetHints(Value: TStrings);
begin
	FHints.Assign(Value);
	InitHints;
end;

procedure TcoDBNavigator97.InitCaptions;
var
	I: Integer;
	J: TNavigateBtn97;
begin
	for J:=Low(Buttons) to High(Buttons) do begin
		Buttons[J].Caption:={$IFNDEF DBNav97Delphi3}LoadStr{$ENDIF}(BtnHintId[J]);
	end;
	J:=Low(Buttons);
	for I:=0 to (FCaptions.Count-1) do begin
		if FCaptions.Strings[I]<>'' then
      with Buttons[J] do begin
        Caption:=FCaptions.Strings[I];
			end;
    if J=High(Buttons) then
      Exit;
    Inc(J);
  end;
end;

procedure TcoDBNavigator97.SetWordWrap(Value: Boolean);
var
	J: TNavigateBtn97;
begin
     if FWordWrap<>Value then begin
        FWordWrap:=Value;
        for J:=Low(Buttons) to High(Buttons) do begin
                Buttons[J].WordWrap:= FWordWrap;
				end;
     end;
end;

procedure TcoDBNavigator97.SetCaptions(Value: TStrings);
begin
     FCaptions.Assign(Value);
		 InitCaptions;
end;

procedure TcoDBNavigator97.SetDisplayMode (Value: TButtonDisplayMode);
var
        J: TNavigateBtn97;
begin
	 if FDisplayMode <> Value then begin
      FDisplayMode := Value;

			for J:=Low(Buttons) to High(Buttons) do begin
          Buttons[J].DisplayMode:=Value;
      end;
		end;
end;

procedure TcoDBNavigator97.InitFont;
var
				J: TNavigateBtn97;
begin
		for J:=Low(Buttons) to High(Buttons) do begin
			 Buttons[J].Font.Assign(Font);
			 end;
end;

procedure TcoDBNavigator97.SetLayout (Value: TButtonLayout);
var
				J: TNavigateBtn97;

begin
	if FLayout <> Value then begin
		 FLayout := Value;

		 for J:=Low(Buttons) to High(Buttons) do begin
				 Buttons[J].Layout := Value;
     end;
  end;
end;

procedure TcoDBNavigator97.GetChildren(Proc: TGetChildProc {$IFDEF DBNav97Delphi3}; Root: TComponent {$ENDIF});
begin
end;

procedure TcoDBNavigator97.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited;
  if (Operation=opRemove) and Assigned(FDataLink) and     (AComponent=DataSource) then
    DataSource:=nil;
end;

procedure TcoDBNavigator97.SetVisible(Value: TButtonSet97);
var
	I: TNavigateBtn97;
	W,H: Integer;
begin
	W:=Width;
	H:=Height;
	FVisibleButtons:=Value;
	for I:=Low(Buttons) to High(Buttons) do
		Buttons[I].Visible:=I in FVisibleButtons;
	SetSize(W,H);
	if (W<>Width) or (H<>Height) then
		inherited SetBounds(Left,Top,W,H);
	Invalidate;
end;

procedure TcoDBNavigator97.SetSize(var W: Integer; var H: Integer);
	var Count: Integer;
			i: TNavigateBtn97;
			X,XOffset,YOffset: Integer;
begin
	if (csLoading in ComponentState) or ( Buttons[nbFirst97] = nil )
		then Exit;
	if (csDesigning in ComponentState) then begin
		XOffset:=0;
		YOffset:=0;
	end else begin
		XOffset:=Left;
		YOffset:=Top;
	end;
	if H < MinBtnSize.Y then H := MinBtnSize.Y;
	Count:=0;
	for i := Low(Buttons) to High(Buttons) do
		if Buttons[i].Visible then Inc(Count);
	if Count=0 then Inc(Count);
	W := Count * ButtonWidth;
//	ShowMessage( Name + IntToStr(Width) ); //TSK
	X	:=0;
	for i := Low(Buttons) to High(Buttons) do
		if Buttons[I].Visible then begin
			Buttons[i].SetBounds(XOffset+X,YOffset,ButtonWidth,Height);
			Inc(X,ButtonWidth);
		end; {else
			Buttons[I].SetBounds (XOffset+Width+2,YOffset,ButtonWidth,Height);}
	if not (csDesigning in ComponentState)
		then Visible:=False;
end;
{var
	Count: Integer;
	MinW: Integer;
	I: TNavigateBtn97;
	Space,Temp,Remain: Integer;
	X,XOffset,YOffset: Integer;
begin
	if (csLoading in ComponentState) or (Buttons[nbFirst]=nil) then
		Exit;
	if (csDesigning in ComponentState) then begin
		XOffset:=0;
		YOffset:=0;
	end else begin
		XOffset:=Left;
		YOffset:=Top;
	end;
	Count:=0;
	for I:=Low(Buttons) to High(Buttons) do
		if Buttons[I].Visible then
			Inc(Count);
	if Count=0 then
		Inc(Count);
	MinW:=Count*MinBtnSize.X;
	if W<MinW then
		W:=MinW;
	if H<MinBtnSize.Y then
		H:=MinBtnSize.Y;
	ButtonWidth:=W div Count;
	Temp:=Count*ButtonWidth;
	if Align=alNone then
		W:=Temp;
	X:=0;
	Remain:=W-Temp;
	Temp:=Count div 2;
	for I:=Low(Buttons) to High(Buttons) do
		if Buttons[I].Visible then begin
			Space:=0;
			if Remain<>0 then begin
				Dec(Temp,Remain);
				if Temp<0 then begin
					Inc(Temp,Count);
					Space:=1;
				end;
			end;
			Buttons[I].SetBounds(XOffset+X,YOffset,ButtonWidth+Space,Height);
			Inc(X,ButtonWidth+Space);
		end else
			Buttons[I].SetBounds (XOffset+Width+1,YOffset,ButtonWidth,Height);
	if not (csDesigning in ComponentState) then
		Visible:=False;
end;}

procedure TcoDBNavigator97.SetBounds(ALeft,ATop,AWidth,AHeight: Integer);
var
	W,H: Integer;
begin
  W:=AWidth;
  H:=AHeight;
	SetSize (W,H);
	inherited SetBounds (ALeft,ATop,W,H);
end;

procedure TcoDBNavigator97.WMSize(var Message: TWMSize);
var
  W,H: Integer;
begin
  inherited;
  W:=Width;
  H:=Height;
  SetSize(W,H);
	if (W<>Width) or (H<>Height) then
		inherited SetBounds(Left,Top,W,H);
	Message.Result:=0;
end;

procedure TcoDBNavigator97.ClickHandler(Sender: TObject);
begin
  BtnClick(TNavButton97(Sender).Index);
end;

procedure TcoDBNavigator97.BtnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
var
	OldFocus: TNavigateBtn97;
begin
	OldFocus:=FocusedButton;
	FocusedButton:=TNavButton97 (Sender).Index;
	if TabStop and (GetFocus<>Handle) and CanFocus then begin
		SetFocus;
		if (GetFocus<>Handle) then
			Exit;
	end else if TabStop and (GetFocus=Handle) and (OldFocus<>FocusedButton) then begin
		Buttons[OldFocus].Invalidate;
		Buttons[FocusedButton].Invalidate;
	end;
end;

procedure TcoDBNavigator97.BtnClick(Index: TNavigateBtn97);
begin
	if (DataSource<>nil) and (DataSource.State<>dsInactive) then
		if not (csDesigning in ComponentState) and Assigned(FBeforeAction) then
			FBeforeAction(Self, Index);
		with DataSource.DataSet do
			case Index of
			nbPrior97:		Prior;
			nbNext97: 		Next;
			nbPgUp97: 		MoveBy( -PageLen );
			nbPgDown97:		MoveBy( PageLen );
			nbFirst97: 		First;
			nbLast97: 		Last;
			nbInsert97:		Insert;
			nbEdit97:			Edit;
			nbCancel97:		Cancel;
			nbPost97:			Post;
			nbRefresh97:	Refresh;
			nbDelete97:
				if (not FConfirmDelete) or (MessageDlg({$IFNDEF DBNav97Delphi3}LoadStr{$ENDIF}(SDeleteRecordQuestion),mtConfirmation,mbOKCancel,0)<>idCancel) then
					Delete;
			end;
//	if not (csDesigning in ComponentState) and Assigned(FOnNavClick) then
//		FOnNavClick(Self,Index);
end;

procedure TcoDBNavigator97.WMSetFocus(var Message: TWMSetFocus);
begin
	Buttons[FocusedButton].Invalidate;
end;

procedure TcoDBNavigator97.WMKillFocus(var Message: TWMKillFocus);
begin
  Buttons[FocusedButton].Invalidate;
end;

procedure TcoDBNavigator97.KeyDown(var Key: Word; Shift: TShiftState);
var
  NewFocus: TNavigateBtn97;
	OldFocus: TNavigateBtn97;
begin
	OldFocus:=FocusedButton;
  case Key of
  VK_RIGHT: begin
			NewFocus:=FocusedButton;
			repeat
        if NewFocus<High(Buttons) then
          NewFocus:=Succ(NewFocus);
      until (NewFocus=High(Buttons)) or (Buttons[NewFocus].Visible);
      if NewFocus<>FocusedButton then begin
        FocusedButton:=NewFocus;
				Buttons[OldFocus].Invalidate;
        Buttons[FocusedButton].Invalidate;
      end;
    end;
  VK_LEFT: begin
      NewFocus:=FocusedButton;
      repeat
        if NewFocus>Low(Buttons) then
          NewFocus:=Pred(NewFocus);
      until (NewFocus=Low(Buttons)) or (Buttons[NewFocus].Visible);
			if NewFocus<>FocusedButton then begin
        FocusedButton:=NewFocus;
        Buttons[OldFocus].Invalidate;
        Buttons[FocusedButton].Invalidate;
      end;
		end;
  VK_SPACE:
    if Buttons[FocusedButton].Enabled then
      Buttons[FocusedButton].Click;
  end;
end;

procedure TcoDBNavigator97.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result:=DLGC_WANTARROWS;
end;

procedure TcoDBNavigator97.DataChanged;
	var Editing, CanModify, UpEnable, DnEnable, ModifyField: Boolean;
begin
	{Check dataset state}
	UpEnable		:= Enabled and FDataLink.Active and not FDataLink.DataSet.BOF;
	DnEnable		:= Enabled and FDataLink.Active and not FDataLink.DataSet.EOF;
	CanModify		:= Enabled and FDataLink.Active and FDataLink.DataSet.CanModify;
	Editing			:= FDataLink.Editing;
// TSK
	ModifyField	:= True;
	if ( FCanModifyField <> nil ) then ModifyField := FCanModifyField.AsBoolean;
// 
	if Editing then begin
		//   ,  .
		Buttons[nbFirst97].Enabled	:= False;
		Buttons[nbPgUp97].Enabled		:= False;
		Buttons[nbPrior97].Enabled	:= False;
		Buttons[nbNext97].Enabled		:= False;
		Buttons[nbPgDown97].Enabled	:= False;
		Buttons[nbLast97].Enabled		:= False;
	end else begin
		//   .
		Buttons[nbFirst97].Enabled	:= UpEnable and (nbFirst97 in VisibleButtons);
		Buttons[nbPgUp97].Enabled		:= UpEnable and (nbPgUp97 in VisibleButtons);
		Buttons[nbPrior97].Enabled	:= UpEnable and (nbPrior97 in VisibleButtons);
		Buttons[nbNext97].Enabled		:= DnEnable and (nbNext97 in VisibleButtons);
		Buttons[nbPgDown97].Enabled	:= DnEnable and (nbPgDown97 in VisibleButtons);
		Buttons[nbLast97].Enabled		:= DnEnable and (nbLast97 in VisibleButtons);
	end;
// .
	Buttons[nbInsert97].Enabled		:= CanModify and (not Editing) and (nbInsert97 in VisibleButtons);
// .
	Buttons[nbEdit97].Enabled			:= CanModify and ModifyField and (not Editing)
																																and (nbEdit97 in VisibleButtons);
// .
	Buttons[nbDelete97].Enabled		:= CanModify and ModifyField and (not Editing)
																																and (nbDelete97 in VisibleButtons);
// .
	Buttons[nbRefresh97].Enabled	:= not (FDataLink.DataSet is TQuery) and (not Editing)
																																and (nbRefresh97 in VisibleButtons);
//     .
	Buttons[nbPost97].Enabled			:= CanModify and Editing and (nbPost97 in VisibleButtons);
	Buttons[nbCancel97].Enabled		:= CanModify and Editing and (nbCancel97 in VisibleButtons);
end;

procedure TcoDBNavigator97.EditingChanged;
	var Editing, CanModify, ModifyField: Boolean;
begin
	CanModify		:= Enabled and FDataLink.Active and FDataLink.DataSet.CanModify;
	Editing			:= FDataLink.Editing;
// TSK
	ModifyField	:= True;
	if ( FCanModifyField <> nil ) then ModifyField := FCanModifyField.AsBoolean;
//   ,  .
	Buttons[nbFirst97].Enabled		:= ( not Editing ) and (nbFirst97 in VisibleButtons);
	Buttons[nbPgUp97].Enabled			:= ( not Editing ) and (nbPgUp97 in VisibleButtons);
	Buttons[nbPrior97].Enabled		:= ( not Editing ) and (nbPrior97 in VisibleButtons);
	Buttons[nbNext97].Enabled			:= ( not Editing ) and (nbNext97 in VisibleButtons);
	Buttons[nbPgDown97].Enabled		:= ( not Editing ) and (nbPgDown97 in VisibleButtons);
	Buttons[nbLast97].Enabled			:= ( not Editing ) and (nbLast97 in VisibleButtons);
	{The other buttons}
	Buttons[nbDelete97].Enabled		:= CanModify and ( not Editing ) and (nbDelete97 in VisibleButtons);
	Buttons[nbInsert97].Enabled		:= CanModify and ModifyField and ( not Editing )
																															and (nbInsert97 in VisibleButtons);
	Buttons[nbEdit97].Enabled			:= CanModify and ModifyField and ( not Editing )
																															and (nbEdit97 in VisibleButtons);
	Buttons[nbPost97].Enabled			:= CanModify and ( Editing ) and (nbPost97 in VisibleButtons);
	Buttons[nbCancel97].Enabled		:= CanModify and ( Editing ) and (nbCancel97 in VisibleButtons);
	Buttons[nbRefresh97].Enabled	:= not (FDataLink.DataSet is TQuery) and (not Editing)
																															and (nbRefresh97 in VisibleButtons);
end;

procedure TcoDBNavigator97.ActiveChanged;
var
	I: TNavigateBtn97;
begin
	if not (Enabled and FDataLink.Active) then
		for I:=Low(Buttons) to High(Buttons) do
			Buttons[I].Enabled:=False
	else begin
		DataChanged;
		EditingChanged;
	end;
end;

procedure TcoDBNavigator97.CMEnabledChanged(var Message: TMessage);
begin
	inherited;
	if not (csLoading in ComponentState) then
		ActiveChanged;
end;

procedure TcoDBNavigator97.SetDataSource(Value: TDataSource);
begin
	FDataLink.DataSource := Value;
	FCanModifyField := nil; //TSK
	if not (csLoading in ComponentState) then ActiveChanged;
	if Value <> nil then Value.FreeNotification(Self);
end;

function TcoDBNavigator97.GetDataSource: TDataSource;
begin
	Result:=FDataLink.DataSource;
end;

procedure TcoDBNavigator97.Loaded;
	var	W,H: Integer;
begin
	inherited;
	W:=Width;
	H:=Height;
	SetSize (W,H);
	if (W<>Width) or (H<>Height) then
		inherited SetBounds (Left,Top,W,H);
	InitHints;
//	InitCaptions;
//	InitFont;
	ActiveChanged;
end;

procedure TcoDBNavigator97.SetButtonWidth(const Value: Integer);
	var W,H: Integer;
begin
	FButtonWidth := Value;
	W:=Width;
	H:=Height;
	SetSize (W,H);
	if (W<>Width) or (H<>Height) then
		inherited SetBounds (Left,Top,W,H);
end;

function TcoDBNavigator97.GetCanModifyFieldName: String;
begin
	Result := '';
	if FCanModifyField <> nil then Result := FCanModifyField.Name;
end;

procedure TcoDBNavigator97.SetCanModifyFieldName(const Value: String);
begin
	FCanModifyField := DataSource.DataSet.FindField( Value );
	if FCanModifyField = nil
		then raise EDatabaseError.CreateFmt( SFieldNotFound, [ Value ] );
end;

{TNavButton97}

procedure TNavButton97.Paint;
var
  R: TRect;
begin
  inherited Paint;
  if (GetFocus=Parent.Handle) and (FIndex=TcoDBNavigator97(Owner).FocusedButton) then begin
    R:=Bounds(0,0,Width,Height);
		InflateRect(R,-3,-3);
    if FState=bsDown then
			OffsetRect(R,1,1);
		DrawFocusRect(Canvas.Handle,R);
  end;
end;

{TNavDataLink97}

constructor TNavDataLink97.Create(ANav: TcoDBNavigator97);
begin
  inherited Create;
  FNavigator:=ANav;
end;

destructor TNavDataLink97.Destroy;
begin
  FNavigator:=nil;
  inherited Destroy;
end;

procedure TNavDataLink97.EditingChanged;
begin
  if FNavigator<>nil then
		FNavigator.EditingChanged;
end;

procedure TNavDataLink97.DataSetChanged;
begin
	if FNavigator<>nil then
		FNavigator.DataChanged;
end;

procedure TNavDataLink97.ActiveChanged;
begin
	if FNavigator<>nil then
		FNavigator.ActiveChanged;
end;

procedure Register;
begin
	RegisterComponents('Toolbar97',[TcoDBNavigator97]);
end;

end.
