{ ==================================================================================================}
{                                                                                                  }
{   - TcoLookupDiction                                                                             }
{            .                                      }
{                                                                                                  }
{  Copyright 1999-2000 TSK Developer Laboratory, Moscow.                       Konstantin Tsvetkov }
{                                                                           e-mail: tsklab@mail.ru }
{==================================================================================================}
unit CommingLookupDiction;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	ExtCtrls, StdCtrls, ComCtrls, RXCtrls, RxLookup, DB;

type
	TcoLookupDiction = class(TFrame)
    LookupCombo: TRxDBLookupCombo;
    PanelButton: TPanel;
    Button: TRxSpeedButton;
	private   { Private declarations }
		function 	GetDataField(): String;
		procedure	SetDataField( Value: String );
		function 	GetDataSource(): TDataSource;
		procedure	SetDataSource( Value: TDataSource );
		function 	GetKeyValue(): Variant;
		procedure	SetKeyValue( Value: Variant );
		function 	GetLookupDisplay(): String;
		procedure	SetLookupDisplay( Value: String );
		function 	GetLookupField(): String;
		procedure	SetLookupField( Value: String );
		function 	GetLookupSource(): TDataSource;
		procedure	SetLookupSource( Value: TDataSource );
		function 	GetDictionClick(): TNotifyEvent;
		procedure	SetDictionClick( Value: TNotifyEvent );
    procedure SetDisplayEmpty(const Value: String);
    procedure SetEmptyValue(const Value: String);
    function GetDisplayEmpty: String;
    function GetEmptyValue: String;
	protected   { Protected declarations }
	public      { Public declarations }
		constructor Create( AOwner: TComponent); override;
	published   { Published declarations }
		property	Align;
//		property	ButtonLeft: Integer read FButtonLeft write FButtonLeft stored True;
		property	DataField: String read GetDataField write SetDataField;
		property	DataSource: TDataSource read GetDataSource write SetDataSource;
		property	KeyValue: Variant read GetKeyValue write SetKeyValue;
    property  EmptyValue: String read GetEmptyValue write SetEmptyValue;
    property  DisplayEmpty: String read GetDisplayEmpty write SetDisplayEmpty;
		property	LookupDisplay: String read GetLookupDisplay write SetLookupDisplay;
		property	LookupField: String read GetLookupField write SetLookupField;
		property	LookupSource: TDataSource read GetLookupSource write SetLookupSource;
		property 	OnDictionClick: TNotifyEvent read GetDictionClick write SetDictionClick;
	end;

procedure Register;

implementation

{$R *.DFM}
//=============================================================================================
constructor TcoLookupDiction.Create( AOwner: TComponent);
begin
	inherited Create( AOwner );
// ShowMessage(	AOwner.Name );
//	Button.Left := ButtonLeft;// Width - 24;
//	LookupCombo.Width := Width - 26;
//	OnResize(AOwner);
end;
//=============================================================================================
{procedure TcoLookupDiction.coLookupDictionResize(Sender: TObject);
begin
//	Button.Left := Width - 24;
//	ButtonLeft := Button.Left;
//	LookupCombo.Width := Width - 26;
end;}
//=============================================================================================
function TcoLookupDiction.GetDataField(): String;
begin
	Result := LookupCombo.DataField;
end;
//=============================================================================================
procedure TcoLookupDiction.SetDataField( Value: String );
begin
	LookupCombo.DataField := Value;
end;
//=============================================================================================
function TcoLookupDiction.GetDataSource(): TDataSource;
begin
	Result := LookupCombo.DataSource;
end;
//=============================================================================================
procedure TcoLookupDiction.SetDataSource( Value: TDataSource );
begin
	LookupCombo.DataSource := Value;
end;
//=============================================================================================
function TcoLookupDiction.GetKeyValue: Variant;
begin
  try
	  Result := LookupCombo.KeyValue;
  except
    Result := 0;
  end;
end;
//=============================================================================================
procedure TcoLookupDiction.SetKeyValue( Value: Variant );
begin
	LookupCombo.KeyValue := Value;
end;
//=============================================================================================
function TcoLookupDiction.GetLookupDisplay(): String;
begin
	Result := LookupCombo.LookupDisplay;
end;
//=============================================================================================
procedure TcoLookupDiction.SetLookupDisplay( Value: String );
begin
	LookupCombo.LookupDisplay := Value;
end;
//=============================================================================================
function TcoLookupDiction.GetLookupField(): String;
begin
	Result := LookupCombo.LookupField;
end;
//=============================================================================================
procedure TcoLookupDiction.SetLookupField( Value: String );
begin
	LookupCombo.LookupField := Value;
end;
//=============================================================================================
function TcoLookupDiction.GetLookupSource(): TDataSource;
begin
	Result := LookupCombo.LookupSource;
end;
//=============================================================================================
procedure TcoLookupDiction.SetLookupSource( Value: TDataSource );
begin
	LookupCombo.LookupSource := Value;
end;
//=============================================================================================
function TcoLookupDiction.GetDictionClick(): TNotifyEvent;
begin
	Result := Button.OnClick;
end;
//=============================================================================================
procedure TcoLookupDiction.SetDictionClick( Value: TNotifyEvent);
begin
	Button.OnClick := Value;
end;
//==================================================================================================
function TcoLookupDiction.GetDisplayEmpty: String;
begin
  Result := LookupCombo.DisplayEmpty;
end;
//==================================================================================================
procedure TcoLookupDiction.SetDisplayEmpty(const Value: String);
begin
  LookupCombo.DisplayEmpty := Value;
end;
//==================================================================================================
function TcoLookupDiction.GetEmptyValue: String;
begin
  Result := LookupCombo.EmptyValue;
end;
//==================================================================================================
procedure TcoLookupDiction.SetEmptyValue(const Value: String);
begin
  LookupCombo.EmptyValue := Value;
end;
//==================================================================================================
procedure Register;
begin
	RegisterComponents( 'Comming', [TcoLookupDiction]);
end;
//==================================================================================================
end.
