{==================================================================================================

  Comming Library

    ToolBar ().

===================================================================================================

  :

  10.12.2002 TSK     CommingDesign  CommingRuntime
  02.07.2001 TSK    Delphi6.
  03.01.2001 TSK     Tag.
  28.12.2000 TSK   .
  09.09.1998 TSK   Comming Library.

===================================================================================================
  Copyright 1998-2002 TSK Developer Laboratory, Moscow.             Konstantin Tsvetkov
                                                                           e-mail: tsklab@mail.ru
===================================================================================================}
unit CommingToolBar;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      StdCtrls, ComCtrls, ExtCtrls, DesignIntf, ToolWin, CommingOther, DesignEditors;

type

{ TcoToolBar }
  TcoToolBar = class( TToolBar )
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    procedure   SortControlByTag;
  published   { Published declarations }
    property    Indent default 3;
    property    EdgeBorders default [ebBottom];
    property    Flat default True;
  end;

{ TcoToolSeparator }
  TcoToolSeparator = class( TToolButton )
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
  published   { Published declarations }
    property    Style default tbsSeparator;
  end;

{ TcoBindingMenu }
  TcoToolBarMenu = Class( TComponentEditor )
  protected   { Protected declarations }
    FControl : TToolBar;
  public      { Public declarations }
    constructor Create(AComponent: TComponent; ADesigner: IDesigner); override;
    procedure   ExecuteVerb(Index: integer); override;
    function    GetVerb(Index: integer): string; override;
    function    GetVerbCount : integer; override;
  end;

  procedure   TagingToolBar( TB: TToolBar );
  function    ControlSortByLeft( Item1, Item2: Pointer ): Integer;
  function    ControlSortByTag( Item1, Item2: Pointer ): Integer;
  procedure   Register;

implementation
//==================================================================================================
{ TcoToolBar }
//==================================================================================================
constructor TcoToolBar.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  Flat        := True;
  EdgeBorders := [ebBottom];
  AutoSize    := True;
  BorderWidth := 1;
  Indent      := 3;
end;
//==================================================================================================
procedure TcoToolBar.SortControlByTag;
  var i: Integer;
//      s: Boolean;
//      r: String;
      l: TList;
begin
  l := TList.Create;
  for i := 0 to ControlCount - 1 do begin
    l.Add( Controls[0] );
    RemoveControl( Controls[0] );
  end;
  l.Sort( ControlSortByTag );
//  TControl(l[0]).Left := 0;
  for i := 0 to l.Count - 1 do begin
    TControl(l[i]).Left := 0;// ControlRight(TControl(l[i-1]));
  end;
  for i := l.Count - 1 downto 0 do InsertControl( TControl(l[i]));
  l.Free;
end;
//==================================================================================================
{ TcoToolSeparator }
//==================================================================================================
constructor TcoToolSeparator.Create(AOwner: TComponent);
begin
  inherited Create( AOwner );
  Style   := tbsSeparator;
  Width   := 8;
end;
//==================================================================================================
{ TcoToolBarMenu }
//==================================================================================================
constructor TcoToolBarMenu.Create(AComponent: TComponent; ADesigner: IDesigner);
begin
  inherited Create( AComponent, ADesigner );
  FControl := TToolBar( AComponent);
end;
//==================================================================================================
procedure TcoToolBarMenu.ExecuteVerb(Index: integer);
begin
  if Index = 0 then TagingToolBar( FControl );
end;
//==================================================================================================
function TcoToolBarMenu.GetVerb(Index: integer): string;
begin
  if Index = 0 then Result := 'Taging Control';
end;
//==================================================================================================
function TcoToolBarMenu.GetVerbCount: integer;
begin
  Result := 1;
end;
//==================================================================================================
procedure TagingToolBar( TB: TToolBar );
  var i: Integer;
      l: TList;
begin
  l := TList.Create;
  for i := 0 to TB.ControlCount - 1 do begin
    l.Add( TB.Controls[i] );
  end;
  l.Sort( ControlSortByLeft );
  for i := 0 to l.Count - 1 do TControl(l[i]).Tag := i + 1;
  l.Free;
end;
//==================================================================================================
function ControlSortByLeft( Item1, Item2: Pointer ): Integer;
begin
  Result := TControl(Item1).Left - TControl(Item2).Left;
end;
//==================================================================================================
function ControlSortByTag( Item1, Item2: Pointer ): Integer;
begin
  Result := TControl(Item1).Tag - TControl(Item2).Tag;
end;
//==================================================================================================
{  }
//==================================================================================================
procedure Register;
begin
  RegisterComponents( 'Comming 97', [ TcoToolBar,  TcoToolSeparator ]);
  RegisterComponentEditor( TcoToolBar, TcoToolBarMenu );
end;
//==================================================================================================
end.
