{==================================================================================================

  Comming Library

     ToolBar97.

===================================================================================================

  :

  23.11.2000 TSK     .  .

===================================================================================================
  Copyright 2000 TSK Developer Laboratory, Moscow.                  Konstantin Tsvetkov
                                                                      e-mail: tsklab@mail.ru
===================================================================================================}
unit CommingToolBar97Ex;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      TB97Tlbr, TB97Ctls, Menus;

type
  TcoToolBar97Ex = class( TComponent )
  private     { Private declarations }
    FBList: TList;
    FDownMenu: TPopupMenu;
    FDownButton: TToolbarButton97;
    FToolBar97: TToolbar97;
    procedure SetToolBar97( const Value: TToolbar97 );
  protected   { Protected declarations }
  public      { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published   { Published declarations }
    property  ToolBar97: TToolbar97 read FToolBar97 write SetToolBar97;
  end;

type
  PxButton = ^TxButton;
  TxButton = record
    Control: TGraphicControl;
    IsButton: Boolean;
    Item: TMenuItem;
    Rating: TDateTime;
    GlyphOnly: Boolean;
    FullWidth: Integer;
  end;

function SortButton( Item1, Item2: Pointer ): Integer;

const DelayGlyphOnly = 1 /( 24 * 60 );  //  

procedure Register;

implementation

{ TcoToolBar97Ex }
//==================================================================================================
constructor TcoToolBar97Ex.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  FBList := TList.Create;
  FDownMenu := TPopupMenu.Create( Self );
end;
//==================================================================================================
destructor TcoToolBar97Ex.Destroy;
begin
  FBList.Free;
  inherited Destroy;
end;
//==================================================================================================
procedure TcoToolBar97Ex.SetToolBar97( const Value: TToolbar97 );
  var i: Integer;
      x: PxButton;
begin
  if FToolBar97 <> Value then begin
    FToolBar97 := Value;
    //    :
    FBList.Clear;
    for i := 0 to FToolBar97.ControlCount - 1 do
      if ( FToolBar97.Controls[i] is TToolbarButton97 ) or
            ( FToolBar97.Controls[i] is TToolbarSep97 ) then begin
        New( x );
        x^.Control    := FToolBar97.Controls[i] as TGraphicControl;
        x^.IsButton   := FToolBar97.Controls[i] is TToolbarButton97;
        x^.FullWidth  := ( FToolBar97.Controls[i] as TGraphicControl ).Width;
        FBList.Add( x );
    end;
    //    :
    FBList.Sort( SortButton );
  end;
end;
//==================================================================================================
function SortButton( Item1, Item2: Pointer ): Integer;
begin
  Result := PxButton( Item1 )^.Control.Left - PxButton( Item2 )^.Control.Left;
end;
//==================================================================================================
procedure Register;
begin
  RegisterComponents( 'Comming', [ TcoToolBar97Ex ] );
end;
//==================================================================================================
end.
